package Algebraico;
use warnings;
use strict;
use GlobalesSimusol;
use Tablasfuncq;
use Termicos;
use Ayudas;
use Controles;
use Data::Dumper;
$Data::Dumper::Indent = 1; 
our ($codconhandles,  $codelems, $codnodos); #definidas en Desdexml
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&aumentar_plantilla
                &asignaciones
                &eliminar_pars
                &estandarizar_expresion
                &limpiar_unico
                &normalizar
                &sust_1par
		&sust_par_nap 
                &sust_par &sust_datos_num &sust_cadena_par
                &explot &crear_parametro
                &realizar_ajustes 
		&QPRODUCTO &QSUMA
                &simpl_constantes
                &simpl_expre_negnum
                &simpl_parametros
       );  
};
END();
my $oper = '[\+\-\*\/]'; #la usa limpiar  
# ----------------------------------------------------------------------------
sub aumentar_plantilla{
  my $nombre = $_[0];
  my $numero = scalar @{$nombreplantilla};
  push(@$nombreplantilla,$nombre);
  $cualplantilla->{$nombre} = $numero;
  return $numero;
} 
# ---------------------------------------------------------------------------
sub estandarizar_expresion{ #lleva numeros a forma estandard
  # y algo sobre espacios 
  # si detecta errores devuelve lo mismo junto con un 
  # codigo de error: s,d,p,f,l
  # s caracteres no admisibles
  # d dobles signos aritmeticos
  # p parentesis mal apareados
  # f faltan operadores
  # l comas invalidas
  # P puntos de más
  # si no detecta error, devuelve expresion estandarizada junto con ''.
  comfin('coml estandarizar_expresion',@_);
  my ($expresion,$que) = @_; my $coderror = '';
  impr_debug(__LINE__.' Alge $exresion',$expresion) if $expresion =~ /\s/;
  my @listsimbolos = split '', $expresion;
  if ($expresion !~                              /^[\w\.\s\,\(\)\+\-\*\/]+$/) {
      if ($expresion =~ /^[\w\.\s\,\(\)\+\-\*\/\:]+$/
             and $que  eq 'TABLAS_ARCHIVOS'){
      } else {die;
          comfin('fin estandarizar_expresion',$expresion,'s');
          return $expresion,'s' #hay caracteres no admisibles
      };	       
  };
  #las posibles XTABLE las lleva a T
  #conviene evitar que el primer argumento de las XTABLE se interprete 
  #como variable y que los XTABLE parezcan indicadores de expresion
  if ($expresion =~ /\w\s+\w/) {
      avnograv(
       " Hay espacios en la expresion $expresion $expresion; se ignoran");
      $expresion =~ s/(\w)\s+(\w)/$1$2/g;
      impr_debug(__LINE__.' Alge $exresion',$expresion)
  };  
  $expresion =~ s/XTABLE\(\s*(T\w+)\,/$1\(/g;
  $expresion =~ /XTABLE/ and 
      avnograv("Expresión con XTABLE no usual
           $_[0];   Se interpreta como indicador de expresión");
  while ($expresion =~ s/(\W)X\w+\s*\(/$1\(/) {}; #saca X.. interiores
  $expresion = '('. $expresion .')';#                 parentesis agregados
  impr_debug(__LINE__.' Alge $exresion',$expresion) if $expresion =~ /\s/;
  $expresion =~ s/\s([\W\S])/$1/g;  $expresion =~ s/([\W\S])\s+/$1/g;
  $expresion =~ s/\*\*/\^/g; #para tener operadores de un solo símbolo
  $expresion =~ s/([\(\,])\+/$1/g; #signos + inutiles
  
  #no se ponen las g porque con detectar uno alcanza
  my @haydobles  = ($expresion =~ /([\+\-\*\/\^])([\+\-\*\/\^])/);
  push @haydobles, ($expresion =~ /[\(\,][\*\/\^]/);
  push @haydobles, ($expresion =~ /([\+\-\*\/\^][\)\,])/); 
  push @haydobles, ($expresion =~ /\,\)/);
  push @haydobles, ($expresion =~ /\(\,/);
  impr_debug(__LINE__.' Alge $exresion',$expresion) if $expresion =~ /\s/;
  if (@haydobles) {
      comfin('fin estandarizar_expresion',$expresion,'d');
      return $expresion, 'd';
  };
  #dobles signos no admisibles

  $expresion =~ s/\^/\*\*/g; # recuperacion de **

  my $resto = $expresion; my $num = 0; 
  while ($resto and $num >= 0) {
      ($num,my $dat,$resto) = sacar_paren_ext($resto);
      $num >= 0 and $resto and $resto =~ s/^[^\(\)]*//;  
      $resto and $resto =~ /^\)/ and $num = -1;
  };# esto solo se usa para detectar errores; no para simplificar
  if ($num < 0) {
      comfin('fin estandarizar_expresion',$_[0],'p');
      return $_[0], 'p'; #parentesis mal apareados
  };
  if (comas_invalidas($expresion)) {
      # expresion viene con sus parentesis exteriores agregados
      $expresion =~ s/^\((.+)\)$/$1/;
      avgrav("Expresion con comas inválidas;\n$expresion");
      comfin('fin estandarizar_expresion',$expresion,'l');
      return $expresion,'l';
  };

  $expresion =~ /\d/ or do{
       $expresion =~ s/^\((.+)\)$/$1/; # ya no tendra los parent.agregados
       comfin('fin estandarizar_expresion',$expresion,'');
       return $expresion, '';# no hay nada más a cambiar
  };
  #my @lissepa = split /[\w\.]+/, $expresion;
  my @lissepa = split /[\w\.\s]+/, $expresion;
  my @lispal = split /[\,\(\)\+\-\*\/\:]+/, $expresion; shift @lispal;
  my @nuelispal;
  for(my $i= 0; $i< @lispal; $i ++) {
      use warnings  FATAL => qw(syntax void);
      my $pal = $lispal[$i];
      $nuelispal[$i] = "$pal$lissepa[$i+1]";
      $pal !~ /^[\.\d]+/ and next;
      if ($pal =~ tr/\.// >1) {
          comfin('fin estandarizar_expresion',$expresion,'P');
          return $expresion, 'P';
      };
      #solo continuan los posibles numeros (digitos y a lo sumo un punto 

      my $valor = eval($pal); 
      if ($@) {
         next unless $i+1 < @lispal and $pal =~ /^[\d\.]+e/i 
                                    and $lispal[$i+1] =~ /^\d+$/;   
	 $pal = "$lispal[$i]$lissepa[$i+1]$lispal[$i+1]";
         $valor = eval($pal);
         if ($@){
             $coderror = 'f';
         } else { 
             my $nvalor = sprintf("%12G",$valor);$nvalor =~ s/\s*//;
             if ($nvalor =~ /E/ and $nvalor !~ /\./) { 
                 $nvalor =~ s/E/.E/;
             };
             $nuelispal[$i] = $nvalor . $lissepa[$i+2];
             $nuelispal[$i+1] = '';
             $i ++;
         }
      } else {
         my $nvalor = sprintf("%12G",$valor);$nvalor =~ s/\s*//;
         $nuelispal[$i] = $nvalor . $lissepa[$i+1];
      };
      $nuelispal[$i] =~ s/^(\d+)(E[+-]\d+)/$1\.$2/;        
      #a sceptre le molesta en las expresiones 5E-4 pero no 5.E-4 
  };#for
  impr_debug(__LINE__.' Alge @nuelispal',\@nuelispal);  
  $expresion = $lissepa[0] . join '',@nuelispal; 
  # $lissepa[0] puede tener mas de un simbolo
  while ($expresion =~ s/([^\w\.])1\*/$1/){};
  while ($expresion =~ s/\*1([^\w\.])/$1/){};
  $expresion =~ /(\)\()/ and $coderror = 'f';
  $expresion =~ s/^\((.+)\)$/$1/; # ya no tendra los parent.agregados
  comfin('fin estandarizar_expresion',$expresion,$coderror);
  return ($expresion,$coderror);
}# estandarizar_expresion
# ----------------------------------------------------------------------------
sub normalizar{ # siempre return ''
  #normaliza expresiones para las que sceptre o simusol adnite varias formas
  #comfin('coml normalizar', @_);
  my ($refcirc, $lisque) = @_; my $VAR1;
  my $sepa  = '[\(\)\+\-\*\/\,\=\']';  
  for my $que (@$lisque) {
      my $ref = $refcirc->{$que};  
      next if not defined $ref;
      foreach my $key (keys %{$ref}) {
	  my $valor = $ref->{$key}; $_ = $valor;
          #impr_debug(__LINE__.' Alge ', $valor); 
          while ($_ =~ s/^\(([^\(\)]+)\)$/$1/) {};
          #saca parentesis exteriores si adentro no los hay 
          $_ =~ s/\s+($sepa)/$1/g; $_ =~ s/($sepa)\s+/$1/g;
          #saca espacios que no revelan  errores 
          #while (s/(\w)\s+(\w)/$1\_$2/){};
          $_ = '('.$_.')'; #para facilitar estudio
	  $valor = $_;
          while (s/($sepa)TIME\s*($sepa)/$1TIEMPO$2/i) {};
          # este cambio para que no se evalue `time` inadvertidamente. 
          s/($sepa)TABL[EA]\s*(\w+)\s*\(/$1T$2\(/gi;
          s/($sepa)E[CQ]UA[TC]ION\s*(\w+)\s*\(/$1Q$2\(/ig;
          s/($sepa)EXPRES{1,2}ION\s*(\w+)\s*\(/$1X$2\(/ig;
          s/(\W)CALCULADO(\W)/$1SIMULADO$2/ig; 
          #no se espera CALCULADO.CALCULADO
          #con el modificador g no consigo hacer lo que quiero
	  $valor = $_;
          while (s/(\w)\s+(\w)/$1&&&$2/){}; #para posiblitar estudio posterior
          s/(\w)&&&(\w)/$1 $2/g; #para posiblitar estudio posterior
          s/^\((.*)\)$/$1/; #los que agregue antes
	  $valor = $_; 
          $ref->{$key} = $valor;
      }; #foreach $key
  };#foreach $que
  #comfin('fin normalizar', $lisque,$refcirc,'impr');
  return '';
} #normalizar
# ----------------------------------------------------------------------------
sub limpiar_unico{# porparar1
  comfin('coml limpiar_unico', @_);
  my ($ref, $lisque) = @_; my $coderr = '';
  my @lisque = @$lisque;
  my ($hayparametros,$haydatos) = ('','');
  impr_debug(__LINE__.' Alge {TIPPARAMETROS}',Dumper $ref->{TIPPARAMETROS});
  impr_debug(__LINE__.' Alge {TIPDATOS}',Dumper $ref->{TIPDATOS});  
  foreach my $que (@lisque) {
      $que eq 'PARAMETROS' and $hayparametros = 1;
      $que eq 'DATOS' and $haydatos = 1;
      foreach my $key (sort keys %{$ref->{$que}}) {
          impr_debug(__LINE__.' Alge limpiar_unico para $key',"          $key");
          if ($que eq 'CONTROLES' and $key eq 'INTEGRATION ROUTINE') {
              my $valor = $ref->{$que}->{$key};
	      cargar_datos($ref,'CONTROLES',$key
			   ,$valor,'a','a',[$valor]);
	      next;
	  };    
          my $datoori = $ref->{$que}->{$key}; my $dato; 
          next if defined $ref->{"TIP$que"}->{$key} 
	      and $ref->{"TIP$que"}->{$key} eq ';';
           my ($func,$tipo,$tiparg)  = ('','','');
          ($dato,my $coderror) = estandarizar_expresion($datoori,$que);
                # sin errores sintácticos, si no coderror
          
          cargar_datos($ref,$que,$key,$dato,'',$coderror,''
                       ,__LINE__.' Alge luego est_expr'); 
          my $reftiparg; 
          if($coderror) {
	      $tipo = 'e'; $tiparg = '';
              $coderror eq 's' and 
                 avgrav("Símbolos no válidos en cuadro $que, $key: $datoori"); 
              $coderror eq 'd' and 
                 avgrav("Sobran operadores en cuadro $que, $key: $datoori"); 
	      $coderror eq 'p' and 
              avgrav("Mal apareo de paréntesis en cuadro $que, $key: $datoori");
              $coderror eq 'f' and
                   avgrav("Faltan operadores en cuadro $que, $key: $datoori"); 
              $coderror eq 'P' and
                   avgrav("Sobran puntos en cuadro $que, $key:) $datoori");
          } else {
              ($coderr,my @listaori) = juntar_por_paren(',',
                                                split (',', $dato));
              map(s/&/\-/g,@listaori);
              my (@dentrito,@funcito,@tipito,@listargcito,@listanue,@refarg);
	      for (my $i = 0; $i < @listaori; $i ++) {
                  ($tipito[$i],$dentrito[$i],$funcito[$i],
                  $listargcito[$i],$listanue[$i],$refarg[$i]) =
                       tipear($ref,$listaori[$i],1);
      	      };#for $i
              if (@listaori == 1) {
	          $tipo = $tipito[0];
                  $func = $funcito[0];
                  $dato = $listanue[0];
		  $tiparg = $listargcito[0];
                  $reftiparg = $refarg[0];
                  defined $reftiparg or $reftiparg = 0;
	      } else {
                  $dato = 'listalis(' . join(',',@listanue) .')';
                  $tipo =',';
                  $tiparg = join '',@tipito;
                  $reftiparg = \@listanue; 
              };
          };#if else $coderror  
          $avisosgrav and 
          do{ porparar1(171,$ref); 
              return 171};
          cargar_datos($ref,$que,$key,$dato,$tipo,$tiparg,$reftiparg
                       ,__LINE__.' Alge limpiar_un'); 
      };#foreach $key
      my $clasearch = $ref->{clasearch};
      impr_debug(__LINE__.' Alge $ref->{clasecapa}',$ref->{clasecapa}); 
      if 
     ($ref->{clasearch} and $ref->{clasearch} eq 'modelo' and $hayparametros) {
	  revisar_parametros($ref);
      };
  }#foreach $que
  comfin('fin limpiar_unico', $lisque,$ref, 'impr');
  return '';
}#limpiar_unico
# ----------------------------------------------------------------------------
sub crear_parametro{
  comfin('coml crear_parametro', @_);   
  my ($ref, $iden, $valor) = @_;
  my $ruf = {};
  $valor =~ /\// and do{
     simpl_inversa($ruf,'PARAMETROS','ppp',$valor);# en crear_parametro
     $valor = $ruf->{PARAMETROS}->{ppp};
  };
  # $iden, identificador causante de la necesidad del parametro
  # $valor, lo que valdrá el parametro
  # $ref recibirá de inmediato el parametro, 
  # hay que cuidar que no se identifiquen dos parametros
  # $refcirc recibirá en el futuro el parámetro (cuando llama despl2circ)
  # REVISAR se necesitan los dos?
  my $newpara = $ref->{valuespar}->{$valor};
  # si el identificador es 'd' no aprovecha que ya este definido para el valor
  #porque el valor es irrelevante
  if (defined $newpara and $iden ne 'd' and length $newpara < 7) {
      #ya hay otro parametro valido con igual valor
  } elsif (defined $ref->{PARAMETROS}->{$valor}) {
     $newpara = $valor; #por si el valor simplificado es un parametro  
  } else { 
     my $numpar = 1;
     #en $ref->{parametroscreados} se mantienen  parametros creados vigentes; 
     #si se borra un parámetro creado anteriormente se borra de ahi
     #comparar con tratamiento de $refcirc->{valuespar}
     while (defined $ref->{PARAMETROS}->{"P$iden$numpar"}) {
        $numpar++;
     };#while
     $newpara = "P$iden$numpar";
     $ref->{parametroscreados}->{$newpara} = 1;
     $ref->{valuespar}->{$valor} = $newpara; 
     push @{$ref->{listaPARAMETROS}}, $newpara; #en crear_parametros
     my $valorsinamper = $valor;
     $valorsinamper =~ s/&//g;
     my ($tipo,$argus,$func0,$listatiparg,$nvalor,$reflistaarg)
                = tipear($ref,$valorsinamper,1); 
     $tipo eq 'e' and 
     porparar1(186,$ref,"Error de sintáxis, en parámetros para $func0,$argus");
     push @{$ref->{lisPARAMETROS}}, $newpara  #en crear:parametros
         unless $tipo =~ /[pane]/;      
     $iden ne 'd' and
     cargar_datos($ref, 'PARAMETROS', $newpara, $nvalor,$tipo,$listatiparg
	   ,$reflistaarg,__LINE__.' Alge crear_par');
     #para $iden 'd' se carga fuera
  };#if elsif else  
  comfin('fin crear_parametro',$valor,$newpara);   
  return $newpara;
}
# ----------------------------------------------------------------------------
sub explot_TQ{
  # todas las argumentos  de funciones Q o tablas deben ser simples
  # no puede haber +-*/
  # se crean parametros PX...
  # seguro que ya no hay llamadas internas a funciones Q
  # porque las ha sacado explot_Q
  # valorpuro sin parentesis
  # y una tabla no puede tener funciones de ningun tipo como argumentos
  my ($ref,$valorpuro) = @_;
  my $valorconpar = "($valorpuro)";
  while ($valorconpar =~ /^(.*\W)([TQ]\w+)(\(.+)$/){  
        # or $valorconpar =~ /^(.*\W)(XTABLE)(\(.+)$/) {
      #marcare con & para no volver a encontrarlo
      my ($comi,$func,$restovp) 
               = ($1,$2,$3);
      my ($tipo) = ($func =~ /^(.)/); $tipo = lc($tipo);
      my ($num,$dat,$resdat) = sacar_paren_ext($restovp);
      my @listaarg = juntar_por_signos_y_paren(',',split (',',$dat));
      my @nuevalistaarg = @listaarg;
      for (my $i=0; $i<@listaarg;$i++) {
           if ($tipo eq 't' and 
                ($listaarg[$i] =~ /\w+\(/)) { 
               $nuevalistaarg[$i]
                      = crear_parametro($ref, 'X', $listaarg[$i])
           };
           next unless $listaarg[$i] =~ /[\+\-\*\/\(\)]/; 
           $nuevalistaarg[$i]
                  = crear_parametro($ref, 'X', $listaarg[$i]);
      };
      $valorconpar = "$comi$func&(" . join(',',@nuevalistaarg) . ")$resdat";
  };#while
  $valorconpar =~ s/\&//g;
  ($valorpuro = $valorconpar) =~ s/^\((.+)\)$/$1/;
  return $valorpuro;
} #explot_TQ
# ----------------------------------------------------------------------------
sub explot_Q{
  # todas las menciones internas de funciones Q dan lugar a parámetros PQ
  # valorpuro sin parentesis
  # se crean parametros QQ
  my ($ref,$valorpuro) = @_;
  while ($valorpuro =~ /^(.*\W)(Q\w+)(\(.+)$/) {
      my ($comi,$func,$restovp) 
               = ($1,$2,$3);
      my ($num,$dat,$resdat) = sacar_paren_ext($restovp); 
      my $nuevopar = crear_parametro($ref, 'Q', "$func($dat)");
      $valorpuro = "$comi$nuevopar$resdat"; 
  };
  return $valorpuro; 
} #explot_Q
# ----------------------------------------------------------------------------
sub explot{
  comfin('coml explot', @_); 
  my ($ref,$lisque) = @_; my $coderr = '';
  # se usa una sola vez por diagrama
  # $lisque se refiere a DATOS, PARAMETROS,  etc (no se usa para nada más);
  #  que pueden necesitar 
  # explotar, y siempre. al final de $lisque, estara 
  # PARAMETROS (que aumentará  si hace falta)
  #{listaPARAMETROS} se refiere a lo que va quedando para quizas imprimir
  #{lisPARAMETROS} a lo que hay que revisar para explotar
  # se crean parametros PS o PQ 
  if ($lisque->[-1] ne 'PARAMETROS') {
      push @{$lisque}, 'PARAMETROS'
  }; 
  @{$ref->{lisDATOS}} = @{$ref->{listaDATOS}} if defined $ref->{listaDATOS}; 
  @{$ref->{lisPARAMETROS}} = @{$ref->{listaPARAMETROS}} 
      if defined $ref->{listaPARAMETROS};
  #las listas anteriores de parametros son actualizadas por crear parametros
  foreach my $que (@$lisque) {
      foreach my $key (@{$ref->{"lis$que"}}) {
          my ($valor,$tipo,$tiparg,$refarg) = tomar_datos($ref,$que,$key);
          next if not defined $valor; #los modelos quedan indefinidos
          #next if $tipo =~ /[pnabrI]/; 
          next unless $tipo =~ /[xfqt]/; 
          #esta undef si un parametro ha sido  sustituido en todos lados?
          next if $tiparg ne '' and $tiparg =~ /^[pna]+$/;
          my ($func,$dentro) = ($valor =~ /^(\w+)\((.+)\)$/);
          #no puede haber llamadas internas a funciones Q:
          if ($dentro =~ /\WQ\w+\(/) {
              $dentro = explot_Q($ref,$dentro) ;
          #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
              $tiparg =~ s/q/p/g;
	  };
          # los argumentos de tablas y de funciones Q 
          # deben ser simples; ( los argum. de funciones Q pueden ser tablas
          # ahora controlamos 
          # para tablas internas 
	  if ($dentro =~ /\W[QT]\w+\(/ ){ 
              #or $dentro =~ /\WXTABLE\(/) {
              $dentro = explot_TQ($ref,$dentro); 
	  };
          if ($tipo =~ /[xf]/) {
              #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
              if ($dentro =~ /^(\w+)(\(.*)$/) {
                  my $qpal = $1; my $restopal = $2; 
                  my ($num,$dat,$resto) = sacar_paren_ext($restopal);
                  if ($resto eq '' and $num = 0) {
		      $restopal =~ s/\)$//;
                      $func = $qpal; $dentro = $dat;
                  } else {
                      $dentro = explot_Q($ref,";$dentro;");
                      $dentro =~ s/^\;(.*)\;$/$1/;
                  };  
	      } elsif ( $dentro =~ /\WQ\w+\(/) {
                  $dentro = explot_Q($ref,$dentro); 
	      };
              ($tiparg, $refarg, $dentro) = tokensep($dentro);
              #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
          } elsif ($tipo =~ /[tq]/) {
              #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
              ($coderr,my @argus) = juntar_por_paren(',',split(',',$dentro));
              my @tipargus = split '',$tiparg;
              for (my $j = 0; $j < @argus; $j++) {
		  next if $tipargus[$j] =~ /[pna]/ 
                         or ($tipo eq 'q' and $tipargus[$j] eq 't');
                  $argus[$j] 
                      = crear_parametro($ref, 'S', $argus[$j]);
                  $tipargus[$j] = 'p';
              };#for $j
              $refarg = \@argus; 
              $tiparg = join '',@tipargus;
	      $dentro = join (',', @argus);
              #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
          };#if else  
          #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
	  $valor = "$func($dentro)";
          cargar_datos($ref, $que, $key, $valor, $tipo, $tiparg,$refarg
                               ,__LINE__.' Alge explot');
      };#foreach $key     
  };#foreach $que
  comfin('fin explot', @{$ref->{lisDATOS}},@{$ref->{lisPARAMETROS}}
                     ,$lisque,$ref,'impr');
  return ''; 
}#explot
# ---------------------------------------------------------------------------
sub simpl_expre_negnum{
  comfin('coml simpl_expre_negnum',@_);
  my ($expresin,$posnum) = @_; 
  $expresin =~ s/(.)$//; my $ult = $1; $posnum = -$posnum;
  $ult eq '+' and return "$expresin-", $posnum; 
  $ult eq '-' and return "$expresin+", $posnum;
  $ult =~ /[\(,\,]/ and return @_;
  return $_[0],"($_[1])";
} #simpl_expre_negnum
# ---------------------------------------------------------------------------
sub simpl_inversa{
  comfin('coml simpl_inversa',@_);
  # se usa con todas las expresiones estandarizadas, 
  # por lo que los 1 se aparecen como 1
  my ($ref,$que,$key,$valor) = @_;
  #sustituyo "**" por "&" (operador para exponenciacion)
  #sustituyo parentesis de tablas (unicas funciones que pueden aparecer aqui
  #abren dod, cierran 3
  #impr_debug(__LINE__.' Alge simpl_inv $key $valor',[$key,$valor]);
  while ($valor =~ s/\((\w+)\)/&&$1&&&/) {};  
  #impr_debug(__LINE__.' Alge simpl_inv $key $valor',[$key,$valor]);
  $valor =~ s/\*\*/\&/g;
  # agrego parentesis exteriores 
  $valor = '('.$valor.')'; 
  #impr_debug(__LINE__.' Alge simpl_inv $valor',$valor);
  my $noopnopar ='[^\+\-\*\/\(\)]';  #acepta el &, lo cual va bien
  my $noop = '[^\+\-\*\/]'; #acepta el &, lo cual va bien 
  my $oppari = '[\+\-\*\/\(]';my $oppard = '[\+\-\*\/\)]'; 
  my $oparit = '[\+\-\*\/]';
  while ($valor =~ 
          s/($noopnopar+)($oparit)\(($noopnopar+)\)/$1$2$3/) {
          #impr_debug(__LINE__.' Alge simpl_inv $valor',$valor);
  };
  while ($valor =~ 
        s/($noopnopar+)\/\(($noopnopar+)\*(($noopnopar+))\)/$1\/$2\/$3/) {
        #impr_debug(__LINE__.' Alge simpl_inv $valor',$valor);
  };
  while ($valor =~ 
          s/($noopnopar+)\/\(($noopnopar+)\/($noopnopar+)\)/$1\/$2\*$3/) {
          #impr_debug(__LINE__.' Alge simpl_inv $key $valor',[$key,$valor]);
  };
  while ($valor =~ 
          s/($noopnopar+)($oparit)\(($noopnopar+)\)/$1$2$2/) {
          #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  };
  $valor = '('.$valor.')'; 
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  while ($valor =~ s/($oppari)\(($noopnopar+)\)/$1$2/) {
     #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  };#saca par. innecesarios  
  while ($valor =~ s/($noopnopar+)\/1\*($noopnopar+)/$1\*$2/){ # 1* xx es xx
     #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  }
  while ($valor =~ s/($noopnopar+)\/1\/($noopnopar+)/$1\/$2/) { # 1* xx es xx
  }
  while ($valor =~ s/([\+\-\(])1\*/$1/){}; # 1* xx es xx
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  while ($valor =~ s/[\*\/]1([\+\-\*\/\)])/$1/) {}; # xx*1, xx/1  es xx
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  # saco los  parentesis exteriores agregados 
  $valor =~ s/^\((.+)\)$/$1/;
  #restituyo los parentesis
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  while ($valor =~ s/&&(\w+)&&&/\($1\)/) {};  
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  #restituyo "&" por "**" (operador para exponenciacion)
  $valor =~ s/&/\*\*/g;
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  my ($tipo,$dentro,$func,$tiparg,$nvalor,$refarg) = tipear($ref,$valor,1);
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$nvalor]);
  cargar_datos($ref,$que,$key,$nvalor,$tipo,$tiparg,$refarg
	       ,__LINE__.' Alge simpl_inversa');
  comfin ('fin simpl_inversa', $nvalor);
} # simpl_inversa
# ----------------------------------------------------------------------------
sub asignaciones{# porparar1
  comfin('coml asignaciones', @_);
  my ($lisque, $refcirc, $sustipar)=@_;
  # en $refcirc->{refvalores}->{$que}->{..}  estan  los renglones tal cual;
  #  se distribuiran en  $refcirc->{$que} interpretados  
  # en %hash se acumulan para hacer control de repetidos
  # por aqui pasan los cuadros DATOS, PARAMETROS, INICIALES, FUNCIONES,
  # TABLAS_ARCHIVOS, CONTROLES, USO, DEFINICION 
  my (@lisasigerror, @valorsinelem); 
  foreach my $que (@$lisque) {
      next unless $refcirc->{refvalores}->{$que};
      impr_debug(__LINE__.' Alge $que',$que);
   #   impr_debug(__LINE__.' Alge {TIPPARAMETROS}'
   #     , Dumper $refcirc->{TIPPARAMETROS}) if $refcirc->{TIPPARAMETROS};
      impr_debug(__LINE__.' Alge {TIPDATOS}'
        , Dumper $refcirc->{TIPDATOS}) if $refcirc->{TIPPARAMETROS};
      my %todos = %{$refcirc->{refvalores}->{$que}};
      my %hash = (); my $cuantasdefi = 0;
      foreach my $numobj ( keys %todos) {
          my @elemsinicono;      
          my $cuadro = descripcion_cuadro($numobj,' ');
          my @lista = @{$todos{$numobj}};
          my $dearchivo = 0;
          if ($cuadro =~ / ARCHIVO/ 
	      and  ($que eq 'PARAMETROS')) {$dearchivo = 1;
	  };
          @lista == 0 and 
          do {avnograv("Sin información el $cuadro"); 
 	      delete $refcirc->{refvalores}->{$que}->{$numobj};
              next;
          };
          @lista   = juntar_por_signos_y_paren(' ',@lista);

	  impr_debug(__LINE__.' Alge @lista',\@lista);
          $refcirc->{definicion} = 
              join("\n", @lista) if $que eq 'DEFINICION';
          foreach my $renglonori (@lista) {
              next unless defined $renglonori;
              if ($renglonori =~ s/([^;]*);/;/) {
                  push @{$refcirc->{"lista$que"}}, $renglonori;
                  cargar_datos($refcirc,$que,'coment',$renglonori,';','',0
                            ,__LINE__.' Alge');  
                  $renglonori = $1; 
                  $renglonori =~ /\S/ or next;
	      };
              #una primer ",", si no hay ningún signo de igual
              # se interpreta como = ; las comas ahi son obsoletas
              my $renglon = uc($renglonori); 
              $renglon =~ s/^\s*(\D\w+)\,([^=]*)/$1=$2/;
	      if ($renglon =~ /[=,]$/) {
                  # solo posible en un  ultimo renglón; incompleto
                  avnoseent("Ultimo renglón \"$renglonori\" en 
                    $cuadro");
                  push @lisasigerror, $que;
 	          next;
	      }; 
              my @listita = split (/\s*=\s*/, $renglon);
              #listita tiene todos los elementos que recibirán valor         
              if (@listita>1) {
                  #asignación, simple; o  múltiple sin sentido para func.
		  my $valor = uc(pop(@listita)); 
                  my $primero = $listita[0];
                  my ($pre, $resto)  = ('',$valor);
                  if ($que eq 'DATOS' or 
                      $que eq 'DEFINICION' and 
                        $primero !~/^P/ and $primero !~/^DP/) {
                      defined $refcirc->{cualobjele}->{$primero} or 
		      do {push @elemsinicono, $primero;
                          next;
                      };  
		      my $obj = $refcirc->{cualobjele}->{$primero}->[0];
                      if ($valor =~ /^(\w)(\w+)\,(.*)/) {
		          my $pcs = $plantillalista->[$obj]
                                .'c'. $shapelista->[$obj];
               	          (my $pr,my $pe,$resto)= ($valor 
                             =~ /^(\w)(\w+)\,(.*)/);
                          $pr =~ /\D/ and $pre = "$pr$pe"; 
                          push @{$refcirc->{tieneparpcsformula}}
                            , [$pcs,$pre];
                      };
                  };
         impr_debug(__LINE__.' Alge $primero,$valor',[$primero,'||',$valor]);   
                  if ($que eq 'USO') {
                      my $coderr = asignacion_USO($refcirc,$primero,$valor);
		      $coderr and return $coderr;
                  } elsif ($sustipar and @listita >1 and 
                      ($resto =~ /^P/    or $resto =~ /\WP/)) {
                         #en algún lugar aparece un parámetro
                      $resto = sust_par_primera($resto,$que,$refcirc);#asignac
	              if ($pre eq '') {$valor = "$resto"; 
                      } else {$valor = "$pre,$resto";
		      };
                  }; #$sustipar
	          foreach (@listita) {# ahora @listita perdio el $valor 
                      s/\s+/ /g;
                      s/\s//g 
                         unless $que eq 'CONTROLES' or $que eq 'INICIALES';
                      if (not /^\w[\w\s]+$/ 
	                  and not ($que eq 'FUNCIONES'  and /^[\w\,\(\)]+$/)) {
                          #aparte de \w, para funciones \( \) \s ,
		          avgrav("Por $renglonori \"$_\" recibe un valor en 
                          $cuadro");
                          push @lisasigerror, $que;
		          next;
	              };	    
	              /^M/ and $que eq 'DATOS'
                       and $valor = adaptar_mutua($refcirc,$que,$_,$valor);
                      my $nombre = uc($_);
                      push @{$refcirc->{"lista$que"}}, $nombre;
                      $refcirc->{$que}->{$nombre} = $valor;
                      push @{$hash{$nombre}}, $valor; $cuantasdefi ++;
                     if ($dearchivo) {
                          $refcirc->{dearchivo}->{$nombre} = 1; 
                      };
	          } #foreach @listita
	      } elsif ($que eq 'CONTROLES') {# @listita == 1 0 no se da; == 0
                  #por aqui pasan todas las sentencias de control sin =
                  $refcirc->{$que}->{uc($renglon)} = 'aaaaaaaa';
                  push @{$refcirc->{"lista$que"}}, uc($renglon);
                  push @{$hash{uc($renglon)}}, 'aaaaaaaa'; $cuantasdefi ++;
              } else {# @listita
                  avgrav(
                  "Falta igual o signo en renglón anterior a
                  \"$renglonori\" en  $cuadro");
                  push @lisasigerror, $que;
                  next;
              };#if @listita      
          };#$renglonori @lista
          if (@elemsinicono) {          
              avnoseent(
              "Se le quiere dar valor a elementos sin ícono en el diagrama,
              en el $cuadro:
              @elemsinicono");
          };
          # control de repetidos
          if ($cuantasdefi > scalar keys %hash) {
	      my $mensaje= '';
 	      foreach my $key (sort keys %hash) {
                  next if @{$hash{$key}} == 1;
                  $mensaje .=  "valores para  $key:\n" . ' ' x 35 .
	          join ("\n" . ' ' x 35, @{$hash{$key}})
              };#foreach $key
             avgrav(
             "Elementos que han recibido más de un valor en cuadro(s)
              $que;    molesta, aunque coincidan\n$mensaje");
	      push @lisasigerror, $que;
          };
      } ;#foreach $numobj
      if ($que eq 'CONTROLES') {
          foreach my $key (keys %{$refcirc->{CONTROLES}}) {
	      next unless $key =~ /^(START|STOP) TIME$/;
	      $refcirc->{tiempo}->{$key} = $refcirc->{CONTROLES}->{$key};
              delete $refcirc->{CONTROLES}->{$key};
          };
      };
      impr_datos(__LINE__.' Alge',[$que],$refcirc);
  };#foreach $que
  if ($avisosgrav) {
      porparar1(170, $refcirc);
      return 170;
  };   
  my @listaque = grep (/DATOS|PARAMETROS|INICIALES|FUNCIONES|CONTROLES/
                       ,@$lisque);
  impr_debug(__LINE__.' Alge @listaque',\@listaque);
  # en CONTROLES puede haber cosas muy variables
  my $coderror = '';
  if (@listaque) {
      $coderror =  normalizar($refcirc, \@listaque);#en asignaciones   
      $coderror and return $coderror;
      $coderror = limpiar_unico($refcirc, \@listaque); #en asignaciones
       $coderror and return $coderror;
  };
  @listaque = grep (/FUNCIONES/,@$lisque);
  @listaque and $coderror = registrar_funciones($refcirc);
  comfin('fin asignaciones', $lisque,$refcirc,'impr');#ya hay impr anteriores
  $coderror and return $coderror;
  if ($avisosgrav) {# YA CONTEMPLADO?
      explic("Definiciones incorrectas en algún cuadro");
      porparar1(172, $refcirc);
      return 172;
  };            
  return '';
}#asignaciones
# ----------------------------------------------------------------------------
sub asignacion_USO{
  comfin('coml asignacion_USO',@_);  
  my ($refcirc,$comodin,$valor ) = @_; my ($nombremodelo,$coderr) = ('','');
  my $uso = $refcirc->{uso} = "$comodin = $valor";;
  impr_debug(__LINE__.' Alge', $uso);
  my @lista = split /\s*,\s*/,$valor;
  $nombremodelo = uc(shift @lista);  
  my @listaargs = @lista;
  map($refcirc->{TIPPARAMETROS}->{$_} = 'W',@listaargs);
  my @listasalida = grep(/$comodin$/,@listaargs);
  impr_debug(__LINE__.' Ampl del uso @listasalida', \@listasalida);
  $refcirc->{salida} = \@listasalida;
  map($refcirc->{TIPPARAMETROS}->{$_} = 'Y',@listasalida);
      # si bien, sobrescritos
#  impr_datos(__LINE__.' Alge ',['DATOS'],$refcirc);die;
  comfin('fin asignacion_USO',$comodin,$nombremodelo);
  return $coderr; 
}#asignacion_USO'  
# ----------------------------------------------------------------------------
sub revisar_parametros{
  comfin('coml revisar_parametros',@_);  
  my ($refcirc) = @_;
  impr_debug(__LINE__.' Alge $refcirc->{PARAMETROS}'
    ,Dumper $refcirc->{PARAMETROS});
  my @listavalues = values %{$refcirc->{PARAMETROS}}; my @listapars;
  foreach my $expr (@listavalues) {
      my @listitas = split /\W+/,$expr; @listitas= grep (/^P/,@listitas);
      push @listapars,@listitas;
  };
  @listapars = union_conjunto(@listapars);    
  my @listaws = grep (do{not defined $refcirc->{PARAMETROS}->{$_}},@listapars);
  map ($refcirc->{TIPPARAMETROS}->{$_} = 'w',@listaws);    
  comfin('fin revisar_parametros');  
}#revisar_parametros;  
# ----------------------------------------------------------------------------
sub adaptar_mutua{
  my ($refcirc, $que, $mm, $valor) = @_;

  my @lista =  split /\s*,\s*/,$valor;
  @lista = juntar_por_signos_y_paren(',',@lista);
  @lista == 3
  and $lista[0] ne $lista[1]
  and defined $refcirc->{cualobjele}->{$lista[0]}
  and  defined $refcirc->{cualobjele}->{$lista[1]}
  and $lista[0] =~ /^L/ and $lista[1] =~ /^L/
  and do{
         $refcirc->{uni}->{$mm} = "$lista[0]-$lista[1]"; 
         return $lista[2];
  } # do
  or avgrav("Dato imposible para una mutua:   $mm = $valor");
  return "$valor con errores";
}
# ----------------------------------------------------------------------------
sub XXX{
    my $valor =  eval($_[0]);
    defined $valor and return $valor 
		      or return 'XXX($_[0])';#esto no tiene efecto
}
# ----------------------------------------------------------------------------
sub qpr_qsu{
  comfin('coml qpr_qsu', @_);
  my ($lisque,$ref,$circmod)=@_; my $coderr = '';
  #sust_datos_num($ref,['PARAMETROS','DATOS']);
  foreach my $que (@$lisque) {#no importa el orden
      foreach my $key (keys %{$ref->{$que}}) {#no importa el orden
          my $tipo = $ref->{"TIP$que"}->{$key};
          next if $tipo ne 'q' ;
          my ($dato) = $ref->{$que}->{$key};
          $dato =~ /^(\w+)\s*\((.+)\)/;
          my $func = $1;
	  ($coderr,my @listarg) = juntar_por_paren(',',split /,/, $2);
           my $tiplistarg = $ref->{"TIPARG$que"}->{$key};
          my @tiplistarg = split ('', $tiplistarg);
	  $tiplistarg = ''; 
          my ($ff,$num);# $ff para el nombre de funcion que queda
          if ($func eq 'QPRODUCTO') {
	      #impr_dat($key,__LINE__.' Alge QPRODUCTO ', $ref,'qq1');
              ($dato, $tipo, $tiplistarg, $ff, $num) =
	        aso_conmu($ref,\@listarg,\@tiplistarg,'*','1','P','0');
                  $ref->{"TIPARG$que"}->{$key} = $tiplistarg; 
              $ref->{FUNUSAFUN}->{$ff}->{$num} = 1 if defined $ff and defined $num;
          } elsif ($func eq 'QSUMA') {
	      impr_dat($key,__LINE__.' Alge QSUMA ', $ref,'qq1');
              ($dato, $tipo, $tiplistarg, $ff, $num) =
	        aso_conmu($ref,\@listarg,\@tiplistarg,'+','0','S');
              $ref->{"TIPARG$que"}->{$key} = $tiplistarg; 
              $ref->{FUNUSAFUN}->{$ff}->{$num} = 1 if defined $ff and defined $num;
	      impr_dat($key,__LINE__.' Alge QSUMA ', $ref,'qq1');

          } else {
              $ref->{FUNUSAFUN}->{$func}->{scalar @listarg} = 1;
	      impr_dat($key,__LINE__.' Alge QSUMA ', $ref,'qq1');
	      next;    
          };
          my ($ntipo,$argus,$nfunc,$listatiparg,$ndato,$reflistaarg) 
                     = tipear($ref,$dato,1);
          cargar_datos($ref,$que,$key,$ndato,$ntipo,$listatiparg,$reflistaarg
                           ,__LINE__.' Alge qpr_qsu');
	      impr_dat($key,__LINE__.' Alge qpr_qsu ', $ref,'--1');
          if ($ntipo eq 'p' and defined $ref->{PARAMETROS}->{$ndato}) { 
              #si no el parametro podria ser TIME o estar dado por su derivada 
	      copiar_datos($ref, 'PARAMETROS', $dato, $ref, $que, $key
                            ,__LINE__.' Alge crar_par');
              $ref->{parametrossustituidos}->{$dato} = 1;  
          };
      };#foreach $key
  };
  sust_par_nap($ref,'[pan]') #en qpr_qsu
     if $circmod eq 'circuito';
  comfin('finl qpr_qsu',$lisque,$ref, 'impr');
  return '';
}#qor_qsu
# ---------------------------------------------------------------------------
sub aso_conmu{
  # use warnings  FATAL => qw(numeric uninitialized);
  # devuelve $valor, $tipo  y si $valor contiene funcioncreada
  # (Q2p por ejemplo)
  # devuelve dato,tipo, $ff, $num, $listatiparg 
  comfin('coml aso_conmu',@_); 
  my ($ref,$refargum,$reftiparg,$oper,$neutro,$simbolo,$absorb) = @_;
  my $resul = $neutro; my (@arg_quedan,@tiparg_quedan);
  for (my $i = 0; $i< @$refargum; $i++) {
       my ($valor,$tipvalor) = ($refargum->[$i],$reftiparg->[$i]);
       return undef,'u','' if not defined $valor or $valor eq '';
       next if $valor eq $neutro;
       return $absorb,'n','' if defined $absorb and $tipvalor eq 'n' and $valor == $absorb;
       if ($tipvalor eq 'n') {
            $resul = eval ($resul . $oper . $valor) ;
       } else {
            push @arg_quedan, $valor; push @tiparg_quedan,$tipvalor;	 
       };
  };#for $i 
  $resul = sprintf "%G",$resul;
  impr_debug(__LINE__.' Alge $resul',$resul);
  impr_debug(__LINE__.' Alge @arg_quedan',\@arg_quedan);
  if (@arg_quedan == 0) {
      my $tiparg = 'n'; $resul <0 and $tiparg = '-n';
      comfin('finl aso_conmu');
      return ($resul,'n',$tiparg,'');
  };    
  if ($resul != $neutro) {
      unshift @arg_quedan, $resul;
      unshift @tiparg_quedan, 'n';
  };
  impr_debug(__LINE__.' Alge @arg_quedan',\@arg_quedan);
  if (@arg_quedan == 0) {
      comfin('finl aso_conmu',$resul,'n');
      return ($resul,'n',$tiparg_quedan[0],'');
 
  } elsif (@arg_quedan == 1) {
      impr_debug(__LINE__.' Alge @arg_quedan',\@arg_quedan);
      if ($tiparg_quedan[0] =~ /[pa]/) {
          comfin('finl aso_conmu',$arg_quedan[0], $tiparg_quedan[0],'');	  
          return ($arg_quedan[0], $tiparg_quedan[0],$tiparg_quedan[0],'')  
      } else { 
          my ($tipo,$argus,$func,$listatiparg,$valor,$reflistaarg) 
            = tipear($ref,$arg_quedan[0],1);#en aso_conmu 
          comfin('finl aso_conmu',$valor, $tipo , $listatiparg);
          return $valor, $tipo , $listatiparg;
      }
  };
  my $nuefunc ='Q' . scalar @arg_quedan . $simbolo;
  my @virtuales ;
  for (my $i=1; $i<= @arg_quedan;$i++) {
       $virtuales[$i-1] = 'XX' . $i;
  };#for $i 
  my $virtuales = join (',',@virtuales);
  my $valor = '(' .join ($oper,@virtuales) .  ')';
  $ref->{definicionFUNCIONES}->{$nuefunc} = "$nuefunc($virtuales) = $valor";
  $ref->{listaargFUNCIONES}->{$nuefunc} = \@virtuales;
  comfin('finl aso_conmu','varios');
  return $nuefunc . '('.join(',',@arg_quedan).')'
         ,'q'
	 , join('',@tiparg_quedan)
	 , $nuefunc
	 , scalar @arg_quedan
	 ;
}#aso_conmu
# ----------------------------------------------------------------------------
sub sust_datos_num{
  #sustiuye menciones a parametros o elementos con valor numerico
  #por su valor
  #no se puede aplicar a DATOS antes de desplegar_ele, por la posible
  #confusion con los codigos de formulas
  #se usa luego de haber interpretado RESULTADOS
  #es muy poco eficiente
  comfin('coml sust_datos_num', @_);
  my ($ref,$lisque,$lisorigen) = @_;
  my (@datosn,@sustn,%quedato,%interesa); my $cuantos = @$lisorigen; 
  my @todosque = union_conjunto(@$lisque,@$lisorigen);
  #impr_datos(__LINE__.' Alge', \@todosque, $ref);
  my $dn= 'dn' . $cuantos;
  map($interesa{$_} = 1, @$lisorigen);
  foreach my $queo (@$lisorigen) {
      my @datqueo = grep (do{$ref->{"TIP$queo"}->{$_} eq 'n'}
                    , keys  %{$ref->{"TIP$queo"}});
      push @datosn, @datqueo;
      map(push(@sustn, $ref->{$queo}->{$_}), @datqueo);
      map($quedato{$_} = $queo,@datqueo);
  };
  # @datosn y @sustn  pueden  crecer si reciben nuevos datos numéricos
  for (my $i= 0; $i < @datosn; $i ++) {
      my $daton  = $datosn[$i]; my $sust = $sustn[$i];
      #impr_dat($daton,__LINE__." Alge sust_datos_n", $ref, 'dn0');
      foreach my $que (@$lisque) {
          foreach my $key (keys %{$ref->{$que}}) {
              my ($valor, $tip, $tiparg,$refarg) 
		  = tomar_datos($ref, $que,$key);
	      defined $tip or do{
                 print STDERR 'Aun no se ha llenado bien ',"$que $key en line "
                     , __LINE__, 'Alg',"\n"; 
                   #se da si no se puso en CONTROLES el START .
                 next;
              }; 
              next if $tip =~ /^[nbtPNT;]/; #saque la ,
             # y el p porque sust_cadena_par puede dejar p, por pos. resultado
              $valor =";$valor;";
              my $cambio = 0; 
	      while ($valor =~ s/(\W)$daton(\W)/\&$2/) {
                   $cambio = 1;
                  my ($pre,$sust1) = ($1,$sust);
                  if ($sust < 0) {
		      ($pre,$sust1) = simpl_expre_negnum($pre,$sust1);
                  };
                  $valor =~ s/\&/$pre$sust1/;
              };
	      next unless $cambio;
 	      $valor =~ s/^;(.*);$/$1/;
              my ($tipo,$argus,$func,$listatiparg,$nvalor,$reflistaarg) 
                        = tipear($ref,$valor,1);# en sust_datos_num 
              $ref->{parametrossustituidos}->{$daton} = 1
		  if $quedato{$daton} eq 'PARAMETROS';
              cargar_datos($ref, $que, $key, $nvalor, $tipo, $listatiparg
                         ,$reflistaarg,__LINE__.' Alge sust_d_n');  
              $tipo eq 'q' and $listatiparg =~ /^n+$/ and do{
                  my $coderr = evaluar_q_n($ref, $que, ($key)); #queda cargado
                  return $coderr if $coderr; 
                  #impr_dat($key,__LINE__.' Alge sust_datos_num',$ref,$dn);
                  $tipo = 'n'; 
              };
              $tipo eq 'n'  and $interesa{$que} and do{
		 push @datosn, $key; push @sustn, $ref->{$que}->{$key};
                 $quedato{$key} = $que;
	      };
          };#foreach $key
      };#foreach $que
  };#foreach $daton
  comfin('fin sust_datos_num', $lisque, $ref, 'impr');
  return '';
}#sust_datos_num
# ----------------------------------------------------------------------------
sub sust_cadena_par{
  # para un parametro es preferible un valor de tipo 'a' o 'p' que un 'n';
  # o incluso un q  f antes que un n
  # pues entonces aunque lo pidan como resultado, podra desaparecer para el 
  # 
  #sustituye en  PARAMETROS con valor un parametro.
  #lo hace en cadena
  #si de un parametro se da la derivada, el parametro no tiene definido el tipo
  #si el valor de un parametro es una lista (tipo ,) no debe sustituirse
  comfin('coml sust_cadena_par', @_);
  my $ref = $_[0];
  #impr_datos(__LINE__.' Alge sust_cadena_par', ['PARAMETROS'], $ref);
  my @lispar = grep(do{$_ !~ /^D/i and $_ !~ /^;/ 
                       and  $ref->{TIPPARAMETROS}->{$_} =~ /[pa]/}
		    , @{$ref->{listaPARAMETROS}});
  impr_debug(__LINE__.' Alge @lispar',\@lispar); 
  foreach my $paro (@lispar) {
      my $sust = $ref->{PARAMETROS}->{$paro};
      defined $ref->{TIPPARAMETROS}->{$sust}
        and $ref->{TIPPARAMETROS}->{$sust} ne 'W' or next; 
      impr_debug(__LINE__.' Alge $sust',$sust);
      impr_debug(__LINE__.' Alge $ref->{TIPPARAMETROS}->{$sust}'
         ,$ref->{TIPPARAMETROS}->{$sust});
      while (defined $ref->{TIPPARAMETROS}->{$sust}
              and  $ref->{TIPPARAMETROS}->{$sust} eq 'p') {
           $sust = $ref->{PARAMETROS}->{$sust}
      };
      $ref->{PARAMETROS}->{$paro} = $sust if $ref->{TIPPARAMETROS}->{$sust}; 
      for my $que ('DATOS','PARAMETROS') {
          foreach my $key (keys %{$ref->{$que}}) {
              my $valor = ";$ref->{$que}->{$key};";
              my $cambio = '';
              while ($valor =~ s/(\W)$paro(\W)/$1$sust$2/){$cambio = 1}
              $cambio and
	      do {$valor =~ s/^;(.*);$/$1/;
                  #$ref->{$que}->{$key} = $valor;
                  my ($tipo,$dentro,$func,$tiparg,$nvalor,$refarg) 
                      = tipear($ref,$valor,1);
                  cargar_datos($ref,$que,$key,$nvalor,$tipo,$tiparg,$refarg
                	       ,__LINE__.' Alge sust_cadena_par');
              };
          };
      };
  };
  comfin('fin sust_cadena_par', ['PARAMETROS'],$ref,'impr');
  return '';
}#sust_cadena_par
#----------------------------------------------------------------------------
sub sust_1_1{
  comfin('coml sust_1_1', @_);
  my ($refo,$queo,$nombreo,$refd,$qued,$nombred,$mensaje) = @_;
  # sustituye el valor de $nombreo en $nombred,  cumpliendo todo lo necesario
  # ya se habra verificado que $valoro parece  aparecer en $valord 
  # devuelve verdadero, 1  si  pudo hacer la sustitucion
  # falso  '' si no pudo 
  # y si debug, deja registro del nuevo valor, a traves de copiar_datos 
  # o cargar_datos
  # seguro ya se controlo no recursion
  #impr_dat_que($nombred,$qued
  #     ,' Alge sust_1_1 '. $mensaje,$refd,'s11');
  my ($valoro, $tipoo, $tipargo,$refargo) = tomar_datos($refo, $queo,$nombreo);
  my ($valord, $tipod, $tipargd,$refargd) = tomar_datos($refd, $qued,$nombred);
  #impr_debug(__LINE__.' Alge'
  #   ,[$nombreo,$valoro, $tipoo, $tipargo
  #    ,$nombred,$valord, $tipod, $tipargd]);
  my $ya = '';
  my $nuevovalor = $valord;
  if ($tipod eq 'p'  and $valord eq $nombreo) {
      copiar_datos($refo,$queo,$nombreo,$refd,$qued,$nombred,$mensaje);
        $ya = 1;
  } elsif ($tipod eq 'q' and $tipoo =~ /[napt]/
           or $tipod eq 'x' and $tipoo =~/[ap]/
           or $tipod eq 'x' and $tipoo eq 'n'  and  $valoro >= 0) { 
      while ($nuevovalor =~ s/(\W)$nombreo(\W)/$1$valoro$2/) {
 	  $ya = 1;
      };
  } elsif ( $tipod =~/[xf]/ and $tipoo eq 'n' and $valoro <0) {
      while ($nuevovalor =~ /(\W)$nombreo(\W)/) {
          my ($pre,$post) = ($1,$2);
          my ($pren,$valorn) = simpl_expr_negnum($pre,$valoro);
	  $nuevovalor =~ s/$pre$nombreo$post/$pren$valorn$post/;
	  $ya = 1;
      };
  } elsif ($tipod eq 'x' and $tipoo eq 't') { 
      #se deja para sceptrear_expr el cambiar por XTABLE
      while ($nuevovalor =~ /^(.*\W)$nombreo(\W)/) {
	  my $pre = $1; 
          if ($pre =~ /T.+\($/) {# no debe sust., quedaria argum. complic.
               $nuevovalor =~ s/^(.*\W)$nombreo(\W)/$1\&$2/;
          } else {
               $nuevovalor =~ s/^(.*\W)$nombreo(\W)/$1$valoro$2/;
	  }
      };
      if ($nuevovalor =~ s/\&/$nombreo/g) {
          $ya =''
      } else {
          $ya = 1
      };      
  } else {
  } 
  if ($ya and $tipod ne 'p' and $nuevovalor ne $valord) {
      my ($tipo,$argus,$func0,$listatiparg,$nvalor,$reflistaarg) 
          = tipear($refd,$nuevovalor,1);
      cargar_datos($refd,$qued,$nombred,$nvalor,$tipo,$listatiparg
                      ,$reflistaarg,$mensaje); 
  };
  comfin('fin sust_1_1');
  return $ya;
} #sust_1_1  
# ---------------------------------------------------------------------------
sub eliminar_pars{
  comfin('coml eliminar_pars',@_);
# se usa para eliminar parametros que solo se usan una vez 
# siendo valor o parte de solo otro dato que puede recibirlo:
# por ser de tipo p,q,x
# no se puede si es un output; para modulos no tenemos outputs
  my ($ref,$clase,@eliminables) = @_;
  foreach my $par (@eliminables) {
      my $cuantos = 0;
      my ($valorpar,$tipopar,$listatipargpar,$refarg) 
               = tomar_datos($ref,'PARAMETROS',$par 
                        ,__LINE__.' Alge eliminar_par');
      my ($recibe, $qued);
      foreach my $que  ('DATOS','PARAMETROS') {
           my @datos = keys %{$ref->{$que}};
           @datos = grep(do {$_ ne $par and defined $ref->{$que}->{$_} 
		       	and ";$ref->{$que}->{$_};"=~ /$par/} ,@datos);
             @datos == 1 and do{$qued = $que; $recibe = $datos[0]};
              $cuantos += @datos; 
              $cuantos >1 and last;
       };
       next unless $cuantos == 1;
       #impr_debug(__LINE__.' Alge', [$par,$qued,$recibe]);
       my $ya = sust_1_1($ref,'PARAMETROS',$par, $ref,$qued,$recibe
                         ,__LINE__.' Alge eliminar_pars');
       #impr_debug(__LINE__.' Alge', [$par,$qued,$recibe,$ya]);
#       if ($ya and $ref->{RESULTADOS}->{lista} !~ /\W$_\W/) {
#           borrar_datos($ref,'PARAMETROS',$par,'',__LINE__.' Alge borrar');
#             delete $ref->{USAPAR}->{$par};
#       };
#       hay un error en =~ pero no loveo ahora      
  };
  comfin('fin eliminar_pars',['DATOS','PARAMETROS'],$ref,'impr');
  return '';
} #eliminar_pars
# ---------------------------------------------------------------------------
sub sust_1par{ 
  comfin('coml sust_1par', @_);
  my ($lisque,$refdespl,$viejo,$nuevo,$tiponuevo,$tipargnuevo,$modo)=@_;
  #$lisque no se espera con 'RESULTADOS'
  # cambia nombre $viejo por $nuevo en los hash's indicados por $lisque
  # referenciados por $refdespl: en los values(entre \W o solo el)
  # $nuevo debe ser un atómico 
  # o una tabla;
  # es decir tiponuevo solo puede ser p,n,a,t (t solo recibirán los q)
  # pero ya se ha usado sust_cadena_par por lo que no hay 
  # parametros cuyo valor sea un parametro (salvo con lista de valores)
  # $modo borrar: el tipo del parametro cambia a mayuscula y no se intentara
  # sustituirlo nunca mas; se incorpora a parametros sustutuidos
  # $modo noborrar: corresponde a cambio de valor; el nombre viejo permanece
  #    pero se cambia su valor y su tipo
  # si el cambio corresponde a nuevo parametro,
  # es decir si $nuevo tipo es p ya debe haber sido creado       
  # devuelve 'si' si hubo alguna sustitucion 'no' en caso contrario
  #impr_datos(__LINE__.' Alge sust_1_par', $lisque, $refdespl); 
  if ($viejo eq $nuevo) {
      error_progr($refdespl, __LINE__. " Alge sust_1par viejo $viejo" );
  };
  my $operparcoma = '[\(\)\+\-\*\/\,]';
  if (not defined $modo) {
      error_progr($refdespl,__LINE__.' Alge: sust_1par $modo indefinido ');
  }
  if (not defined $refdespl->{PARAMETROS}->{$viejo}
      #and not defined $refdespl->{PARAMETROS}->{"D$viejo"}
        ){
      error_progr($refdespl,__LINE__.' Alge: sust_1par ');
  };
  #impr_debug(__LINE__.' Alge listaINICIALES',$refdespl->{listaINICIALES} );
  #impr_debug(__LINE__.' Alge INICIALES',$refdespl->{INICIALES} );
  #impr_datos(__LINE__.' Alge sust_1par', $lisque,$refdespl);
  #impr_debug(__LINE__ .' Alge i.d:s_1p |sust_1p',"$viejo=>$nuevo $modo;");
  #impr_debug(__LINE__ .' Alge i.d:s_1p |sust_1p', $lisque);
  foreach my $que (@$lisque) { 
      my @lisvar = sort keys %{$refdespl->{$que}};#recibirán cambios
      @lisvar = grep(lc($refdespl->{"TIP$que"}->{$_}) =~ /[pxfq,]/,@lisvar);
      if (lc($tiponuevo) eq 't') {
           @lisvar =grep ($refdespl->{"TIP$que"}->{$_} =~ /[pq,]/ ,@lisvar);
      } elsif ($tiponuevo =~ /qfx/) {
           @lisvar =grep ($refdespl->{"TIP$que"}->{$_} =~ /[p,]/ ,@lisvar);  
      };
      #impr_debug(__LINE__.' Alge sust_1par reciben (pos):', \@lisvar);
      foreach my $key (@lisvar) {
          my ($valorkey,$tipokey,$listatipargkey,$refarg) 
               = tomar_datos($refdespl,$que,$key ,__LINE__.' Alge sust_1par');
          impr_dat_que($key,$que,__LINE__.' Alge ',$refdespl,'su1');
          next if $valorkey =~ /^;/ or not defined $tipokey;
          next if $tipokey =~ /[naez]/;
          next unless ";$valorkey;" =~ /\W$viejo\W/;
          impr_debug(__LINE__ .' Alge i.d:sp '," $key $viejo=>$nuevo $modo");
          if ($valorkey eq $viejo) { #seguro que el $tipokey era  p
              # cambios atomicos
               cargar_datos(
                 $refdespl,$que,$key,$nuevo,$tiponuevo,$tipargnuevo,0
                             ,__LINE__.' Alge sust_1par');
               $refdespl->{parametrossustituidos} ->{$viejo} = 1;
               next;
       	  };
          # si es p sera otro distinto de $viejo
          # se han cambiado los $viejo que aparecían en forma atomica; 
          # faltan los que aparecen integrando moleculas
          # quedan todos con $func o 'X..'         
          error_progr($refdespl,__LINE__.' Alge sust_1par no hay func'  
                                . " $key $valorkey")
                unless $valorkey =~ /(\w+)(\(.+\))/;
	 my $func = $1; my $argus = $2; my $tipo; my $listatiparg;
         my $cambio =''; # $argus con sus parentesis
         #impr_debug(__LINE__.' Alge sust_1par $argus', $argus);  
         while ($argus  
	        =~ s/($operparcoma)(\s*)($viejo)(\s*$operparcoma)/\&$4/i) { 
            $cambio = 1;
            my ($oper1,$nuevo1) = ($1,$nuevo);
	    if ($tiponuevo eq 'n' and $nuevo1 < 0) {
		($oper1, $nuevo1) = simpl_expr_negnum($oper1,$nuevo1);
            };
            $argus =~ s/\&/$oper1$nuevo1/;
	};#while  
        #impr_debug(__LINE__.' Alge sust_1par $argus', $argus);  
        next unless $cambio;
        $refdespl->{parametrossustituidos}->{$viejo} = 1; 
	$argus =~ s/^\((.+)\)$/$1/;
        if ($tiponuevo ne 'p') {
	      #si fuera igual a p no cambiaria el tiparg ni el tipo
            ($tipo,$argus,$func,$listatiparg,my $valor,my $reflistaargus) 
                = tipear($refdespl,"$func($argus)",1);#en sust_1par 
            cargar_datos($refdespl, $que, $key, $valor, $tipo, $listatiparg
                     ,$reflistaargus,__LINE__.' Alge sust_1par');
            $tipo eq 'q' and $listatiparg =~ /^n+$/ and do {
                my $coderr = evaluar_q_n($refdespl,$que,($key)); 
                $coderr and return $coderr}; 
	} else {
            $refdespl->{$que}->{$key} = "$func($argus)";
	};
         #impr_dat($key,__LINE__.' Alge sust_1par',$refdespl,'sp2');
     };#foreach $key de @lisvar
  };#foreach $que 
  #impr_dat($viejo,__LINE__.' Alge sust_1par',$refdespl,'sp3');
  if ($modo eq 'borrar' and $viejo ne $nuevo ) {
      $refdespl->{TIPPARAMETROS}->{$viejo} 
            = uc($refdespl->{TIPPARAMETROS}->{$viejo});
  } elsif ($modo eq 'noborrar'){
      $refdespl->{PARAMETROS}->{$viejo} = $nuevo;
      $refdespl->{TIPPARAMETROS}->{$viejo} = $tiponuevo;
      # REVISAR por TIPARGPA...  };#if
      #impr_dat($viejo,__LINE__.' Alge sust_1par',$refdespl,'sp3');
  };
  comfin('finl sust_1par',$lisque,$refdespl,'impr');
  return '';
}#sust_1_par     
# ----------------------------------------------------------------------------
sub simpl_parametros{
  #sustituye parametros atomicos (o tablas) en otros parametros   
  #detecta recursion simple
  comfin('coml simpl_parametros', @_);
  my $refc = $_[0]; my $coderr;
  impr_datos(__LINE__.' Alge',['PARAMETROS'],$refc); 
  my @params1 = sort keys %{$refc->{PARAMETROS}};
  my @params = @{$refc->{listaPARAMETROS}};  
  @params = grep($_ !~ /^\;/,@params);
  my @inicintegr = grep(defined $refc->{PARAMETROS}->{"D$_"}, @params);
  #impr_datos(__LINE__.' Alge', ['PARAMETROS','INICIALES'], $refc);
  @params = grep(do{not defined $refc->{PARAMETROS}->{"D$_"}},@params);
  #impr_debug(__LINE__.' Alge @params', \@params);
  my @evaluables =  grep(do{$refc->{TIPPARAMETROS}->{$_} eq 'q'
                           and $refc->{TIPARGPARAMETROS}->{$_} =~ /^n+$/ 
                         }, @params);
  if (@evaluables) {
      $coderr = evaluar_q_n($refc,'PARAMETROS',@evaluables);
      return $coderr if $coderr;
  };
  my @atomicos = grep(do{$refc->{TIPPARAMETROS}->{$_}
             and $refc->{TIPPARAMETROS}->{$_} =~ /[nap]/}, @params); 
  return '' unless @atomicos;
  impr_debug(__LINE__.' Alge @atomicos',\@atomicos);
  my @cambiables = grep(do{$refc->{TIPPARAMETROS}->{$_} =~ /[xqt]/
                           and $refc->{TIPARGPARAMETROS}->{$_} =~ /p/
                          }, @params);
  @cambiables = union_conjunto(@cambiables);
  impr_debug(__LINE__.' Alge @cambiables',\@cambiables); 
  if (@cambiables) {
      #los atomicos pueden crecer y los cambiables (se recalculan)  disminuir
      foreach my $ato (@atomicos) {
          last unless @cambiables;
          next if $refc->{parametrossustituidos}->{$ato};
          my $valorato = $refc->{PARAMETROS}->{$ato}; 
          my $sustato = '';
          my $tipvalorato = $refc->{TIPPARAMETROS}->{$ato};
          #no hay peligro de recursion; ya se controlo
          foreach my $cam (@cambiables) {
	      my $cambiocam = '';
	      my $valorcam = ';' . $refc->{PARAMETROS}->{$cam} . ';';
              next unless $valorcam =~ /\W$ato\W/; #no hace falta
              while ($valorcam =~ s/(\W)\s*$ato\s*(\W)/\&$2/i){
                  my ($pre,$valorato1) = ($1, $valorato);  
                  if ($tipvalorato eq 'n' and $valorato1 <0) {
		      ($pre, $valorato1) 
                           = simpl_expre_negnum($pre,$valorato1);
                  };                  
                  $valorcam =~ s/\&/$pre$valorato1/;    
	          $cambiocam =1; $sustato = 1;
	      };
	      $cambiocam and do{
                $valorcam =~ s/^;(.+);$/$1/;
	        my ($tipo, $argus, $func, $listatiparg
                    , $nvalor,$reflistaargus) = tipear($refc,$valorcam,1);
	          cargar_datos(
                    $refc, 'PARAMETROS', $cam, $nvalor, $tipo, $listatiparg
                          , $reflistaargus, __LINE__.' Alge simpl_par');
	          $tipo =~ /[nap]/ and $cam =~ /^P/ and push @atomicos, $cam;
	      };
          }; #cambiables
          $sustato  and do{
              $refc->{parametrossustituidos}->{$ato} = 1;
          };
	  @cambiables = grep($refc->{TIPARGPARAMETROS}->{$_} =~ /p/
				 ,@cambiables);
          @cambiables = union_conjunto(@cambiables);
      };
      @evaluables =  grep(do{$refc->{TIPPARAMETROS}->{$_} eq 'q'
                           and $refc->{TIPARGPARAMETROS}->{$_} =~ /^n+$/ 
                         }, @params);
      if (@evaluables) {
          @evaluables = union_conjunto(@evaluables); 
          $coderr = evaluar_q_n($refc,'PARAMETROS',@evaluables);
          return $coderr if $coderr;
          push @atomicos, @evaluables;
      };
  };
  comfin('fin simpl_parametros',['PARAMETROS'], $refc, 'impr');
  return '';
}
# ----------------------------------------------------------------------------
sub sust_par_primera{
  #la usa &asignaciones para asignar a todos los de una cadena  ...=...=...=
  #y sustituye todos los parametros atomicos
  #seguro no hay recursion primaria del tipo Pxxx = Pxxx
  comfin('coml sust_par_primera', @_);
  my ($expresion,$que,$refc) = @_;
  impr_debug(__LINE__.' Alge {TIPDATOS}',Dumper $refc->{TIPDATOS});
  impr_debug(__LINE__.' Alge {TIPPARAMETROS}',Dumper $refc->{TIPPARAMETROS});
  impr_debug(__LINE__.' Alge {PARAMETROS}',Dumper $refc->{PARAMETROS});
#  revisar_parametros($refc);
  my @atomicos = grep($refc->{TIPPARAMETROS}->{$_} =~ /[pant]/
                     ,sort keys %{$refc->{PARAMETROS}});
  #impr_debug(__LINE__.' Alge @atomicos',\@atomicos);
  $expresion = ";$expresion;";
  #impr_debug(__LINE__." Alge $que", $expresion);
  foreach my $ato (@atomicos) {
      my $tipoato =  $refc->{TIPPARAMETROS}->{$ato}; 
      next if $que eq 'RESULTADOS' and $tipoato =~ /[nt]/;
      my $sustato = '';
      my $valorato = $refc->{PARAMETROS}->{$ato};
      $tipoato eq 'n' and 
      $valorato =~ /^\-/ and $valorato = "($valorato)";
      my $cambioexpresion = '';
      #impr_debug(__LINE__." Alge $que $ato", $expresion);
      # no deben sustituirse los argumentos de tablas; cambio las P peligrosas
      while ($expresion =~ s/(\WT\w+)\(([^\(\)P]*)P/$1\($2&/) {};
      #impr_debug(__LINE__." Alge $que", $expresion);
      while ($expresion =~ s/(\W)\s*$ato\s*(\W)/$1$valorato$2/i) {
	  $cambioexpresion = 1;
      };
      #impr_debug(__LINE__." Alge $que", $expresion);
      $expresion =~ s/&/P/g;
      #impr_debug(__LINE__." Alge $que $ato", $expresion);
      $cambioexpresion and $refc->{parametrossustituidos}->{$ato} = 1;
  };
  #impr_datos(__LINE__.' Alge sust_par_prim'
  #      , ['DATOS','PARAMETROS','INICIALES'], $refc);
  #impr_debug(__LINE__." Alge $que", $expresion);
  $expresion =~ s/^;(.+);$/$1/;
  #impr_debug(__LINE__." Alge $que", $expresion); 
  comfin('fin sust_par_primera');
  return $expresion;
}#sust_par_primera
# ----------------------------------------------------------------------------
sub sust_par_nap{
  comfin('coml sust_par_nap', @_);
  # sustituye todos los parametros con tipo que responde a $reg 
  # (casi siempre $reg es /[nap]/)
  # y como nunca más debera sustituir, cambia el tipo a su mayuscula
  # (nunca elimina del todo los parámetros)
  my ($ref,$reg) = @_;
  #impr_datos(__LINE__.' Alge sust_par_nap', ['PARAMETROS'], $ref);
  my @lispartotal
      = grep ($_ !~ /^D/, sort keys %{$ref->{PARAMETROS}}); # en sust_par_nap
  # los otros se llevaran a controlar_integrables
  my @lispar = grep ($ref->{TIPPARAMETROS}->{$_} =~ /$reg/, @lispartotal);
  my $lisque = ['DATOS','PARAMETROS'];
  while (@lispar) {#esta lista de parámetros va cambiando 
      foreach my $par (@lispar) {
          my ($valor,$tipopar,$tipargpar,$refarg) =
               tomar_datos($ref,'PARAMETROS',$par
			   , __LINE__.'Alge sust_par_nap');
          error_progr($ref, ' Alge: sust_par_nap - recursividad ' . __LINE__)
              if $par eq $valor;
              # no debe ocurrir porque se ha controlado recursion
          my $modo = 'borrar';
          sust_1par($lisque, $ref, $par, $valor, $tipopar,'' #en sust_par_nap
                   ,$modo,__LINE__.' Alge en sust_par_nap');
          $ref->{TIPPARAMETROS}->{$par} = uc($ref->{TIPPARAMETROS}->{$par}) 
                if $modo eq 'noborrar';
      };#foreach $par
      # pueden aparecer más parametros con valor tipo n
      @lispartotal 
         = grep ($_ !~ /^D/, sort keys %{$ref->{PARAMETROS}});#en sust_par_nap 
      # el anterior @lispartotal se pudo haber modif.
      @lispar = grep ($ref->{TIPPARAMETROS}->{$_} =~ /$reg/, @lispartotal);
  };#while 
  comfin('fin sust_par_nap',$lisque, $ref, 'impr');
  return '';
}#sust_par_nap     
# ----------------------------------------------------------------------------
sub realizar_ajustes{
    comfin('coml realizar_ajustes', @_);
   my ($ref,$circmod) = @_;
   my @controles = keys %{$ref->{CONTROLES}};
   foreach my $key (@controles) {
       my ($valor,$tipo,$tiparg,$refarg) 
            = tomar_datos($ref,'CONTROLES',$key);
       next if $tipo =~ /[an;\,]/;
       if ($tipo eq 'p') {
           my ($valorp,$tipop,$tipargp,$refargp) 
                = tomar_datos($ref,'PARAMETROS',$valor);
           if ($tipop =~ /[n\,]/) {
               cargar_datos($ref,'CONTROLES',$key, $valorp,'n','');
               $ref->{USAPARCONTROLES}->{$valor} = 1;
               last;
           };
       };
       parar1(66,$ref,"$key, del cuadro CONTROLES no consiguió
                  un valor numérico sino $valor");     
   };    
   qpr_qsu(['PARAMETROS','DATOS','INICIALES'], $ref,$circmod);
   ajustar_definiciones($ref);
   comfin('fin realizar_ajustes');
   return '';
}
#------------------------------------------------------------------------------
sub ajustar_definiciones{
  comfin('coml ajustar_definiciones', @_);
  #sustituye parametros con valor tipo tabla en funciones Q y en expresiones
  #antepone 'XXX' para funciones 'f' o variables extrañas
  # elimina doblesparentesis
  my $ref = $_[0];
  # f.FORTRAN en expres  numerar expresiones
  my $lisque = ['DATOS','PARAMETROS'];
  foreach my $que (@$lisque) {
      foreach my $key (sort keys %{$ref->{$que}}) {#importa el orden
          my ($dato,$tipo,$tiparg,$refarg)
               = tomar_datos($ref,$que,$key,__LINE__.' Alge aj.def');
          my $cambio = 0;
          $dato = "($dato)";
          if ($cambio) {
              $dato =~ s/^\((.+)\)$/$1/;
 	      $ref->{$que}->{$key} = $dato;
          };
          $dato =~ s/^\((.+)\)/$1/;
          next unless $tipo =~ /[afxs]/;

          # las funciones de fortran y las variables del sceptre no pueden
          # estar solas; si o si deben estar en expresiones
          if ($tipo =~ /[as]/) {
              $ref->{"TIPARG$que"}->{$key} = $ref->{"TIP$que"}->{$key};
              $ref->{$que}->{$key} = "XXX($ref->{$que}->{$key})";
	      $ref->{"TIP$que"}->{$key} ='x';
              $ref->{"REFARG$que"}->{$key} = [$dato];
              $dato = "$ref->{$que}->{$key}";
	  } elsif ($tipo eq 'f') {
              my ($func,$dentro);
              if ($dato =~ /^(\w+)\((.+)\)/) {
                 ($func,$dentro) = ($1,$2);
	      } else {error_progr($ref,__LINE__.' Alge  inesperado');
              };  
              ($tiparg,$refarg,$dentro) = tokensep($dentro);
              cargar_datos($ref,$que,$key,"XXX($func($dentro))",'x',$tiparg
                           ,$refarg
			   ,__LINE__.' Alge  aj.def');
          }
          #los identificadores de expresiones no pueden estar repetidos
      }; # key
  };# $que 

  my @lispar = sort keys %{$ref->{PARAMETROS}}; # en ajustar_definiciones
  my @lispart = grep(lc($ref->{TIPPARAMETROS}->{$_}) eq 't',@lispar);

  # sustituye con precauciones del caso los parametros con valor tabla
  foreach my $par (@lispart) {
      my $valor = $ref->{PARAMETROS}->{$par};
      my $tiparg = $ref->{TIPARGPARAMETROS}->{$par};
      my $lisque = ['PARAMETROS','DATOS'];
      sust_1par($lisque,$ref,$par,$valor,'t',$tiparg,'noborrar'); #ajus_def.
  };
  my @lisparx =  grep($ref->{TIPPARAMETROS}->{$_} =~ /[xf]/,@lispar);
  foreach my $par (@lisparx) {
      my $valor = $ref->{PARAMETROS}->{$par};
      next unless $valor =~/\//;
      #impr_dat($par,__LINE__.' Alge aj_def',$ref,'aj');
      simpl_inversa($ref,'PARAMETROS',$par,$valor); #en ajustar_definic
  };
  my @lisdatx =  grep($ref->{TIPDATOS}->{$_} =~ /[xf]/,keys %{$ref->{DATOS}});
  foreach my $dat (@lisdatx) {
      my $valor = $ref->{DATOS}->{$dat};
      next unless $valor =~/\//;
      #impr_dat($dat,__LINE__.' Alge aj_def',$ref,'aj');
      simpl_inversa($ref,'DATOS',$dat,$valor); #en ajustar_definic
  };

  comfin('fin ajustar_definiciones', ['DATOS','PARAMETROS'] , $ref,'impr');
  return ''; 
} #ajustar_definiciones 
1;
