package GlobalesSimusol;
#variables y constantes globales
use warnings;
use strict;
use Ayudas;
use Data::Dumper;
use Text::Abbrev;
$Data::Dumper::Indent = 1; 
our $INSTALLDIR = '/usr/local'; 
#our $INSTALLDIR = '/home/loli/maq_luis';
our $HOMEDIR = $ENV{HOME}; 
#our $INSTALLDIR = "$HOMEDIR/binlib";
our $SIMUSOLBINDIR =  "$INSTALLDIR/bin";
our $SIMUSOLLIBDIR =  "$INSTALLDIR/lib";
our $INSTDIR; #directorio que tendrá los ejecutables de sceptre
#if (-e "$INSTALLDIR/bin/sceptre") {
#    $INSTDIR = $INSTALLDIR
#} else { 
    $INSTDIR = `which sceptre`;
    $? and die " sceptre no está disponible\n";
    chomp $INSTDIR;
    $INSTDIR =~ s/\/bin\/sceptre//;
#}; 
our $LIBDIR = "$INSTDIR/lib";
our $BINDIR = "$INSTDIR/bin";
our $version= 0.87;

our %extension = (
      'simusol' => 'dia'
    , 'simusol_sceptre' => 'd'
    , 'simusol1.pl' => 'dia'
    , 'simusol2.pl' => 'dirac'
    , 'simusol3.pl' => 'paraplot'
    , 'sim_renback' => 'dia'
		     );

our $PRINCIPAL; #nombre del archivo principal para el procesamiento
    # si no se conoce de entrada, porque se dan varios,  se usa 'simusol'
    # los mensajes se mandan a $PRINCIPAL.lss1
our $algo = chr(31) . chr (139) . chr(8) ;$algo ='^' . $algo; 
  #lo anterior identifica archivos comprimidos
our %progr = ('simusol' => 0,'simusol1.pl' => 1, 'simusol_sceptre' => 's'
          , 'simusol2.pl' => 2, 'simusol3.pl' => 3);
our %opt_hash; #cada script comparte variables our con las subrutinas 
# llamadas por el ( siempre que ...
# pero dos scripts (uno llama al otro pero a traves de system) 
# no comparten esas variables; simusol y simusol1.pl no comparten $opt_hash
our %nombresusados; #key nombre de elemento no rama; general; values 1;
    #se usa para cuando hay que crear elementos JN...
our %expr_usadas; #key identificacion de expres. usadas


#our %modelo; #key nombre del modelo; value referencia a los datos del
    # circuito que lo definio; $defimod sustituye       
#our %circ_model; #hash con key nombre (CORTO) de archivo y 
    #value referencia al  hash con datos del circuito
our %reffi;# hash de referencias a datos de archivos; key nombres de
     #archivo; value referencia a un hash 
our %reffipri;# hash de referencias a datos de archivos complementarios;
    # key nombres de archivo; value referencia a un hash 
our %refficompl;# hash de referencias a datos de archivos complementarios
    # de uno dado;
    # key nombres de archivo principal; value referencia a un hash  
    #que tiene como keys nombres de archivos secundarios
our %clasearchivos; #hash con key nombre de archivo y value: 
    # modelo, elementos  o circuito 
#our (%falta_pcs,%falta_uni,%falta_modelo); 
our @dirplantiquedan;
our $cuantosiconos = {}; #apunta a hash con keys de plantilla;
our @reflayer; #array de referencias a hash con características de las
    # layers;
our @nomcirc; #index el numero de layer
our $CAJAS = {}; #referencia a hash 
                #con key nombre de archivo de tipo circuito,  o modelo
		#y value el texto de las cajas y alguna otra cosa
#referencia a listas con palabras codificadas
our ($nombrelay, $nombreplantilla, $nombreshape ,$nombreelemento)
    = ([],[],[],[]);
  #$nombrelay'}       #capas
  #$nombreplantilla'} #primeras partes de nombres de shapes
  #$nombreshape'}     #segundas partes de nombres de shapes
  #$nombreelemento'}  #nombres de elementos en cuadro USO_DEF
#referencia a listas de codigos de los objetos de los diagramas leidos
our ($laylista, $plantillalista, $shapelista, $codlista
   , $codvalorlista, $textolista, $lugarlista) 
    = ([], [], [], [], [], [], []);
  #$laylista        #de la capa (por orden de lectura luego de ..)
  #$plantillalista  #de la primera parte del nombre de la forma
  #$shapelista      #de la segunda parte del nombre de la forma 
  #$codlista        #como elemento (fundam. para sceptre)
  #$codvalorlista   #junto con codlista identifican icono
  #$textolista      #identif. del elemento en el diagrama
  #$lugarlista      #lugar en diagrama
# referencia a hashes                        
our ($cualplantilla, $cuallay, $cualshape, $cualelemento) = ({}, {}, {}, {}); 
  #$cualplantilla)  #nombredeplantilla => lugar en la lista de plantillas
  #$cuallay         #nombre de capa => lugar en la lista global de capas
  #$cualshape       #nombre de shape = > lugar en la lista de shapes
  #$cualelemento    #nombre de elemento => lugar en la lista

# referencia a hashes   con key $pcs
                               #dado en diagrama de definicion de elementos
our ($comonombre,$comocod, $comocodvalor, $comootrosnodos) = ({}, {}, {}, {});
  #$comonombre      #plantillacshape => nombre del elemento 
  #$comocod         #plantillacshape => codigo (de letra, sceptre)
  #$comocodvalor    #plantillacshape => codigo (de letra, fórmula)

#hashes con definiciones resultantes de archivos .ele .mod y similares
#con key $plantilla (primera parte de  nombre de forma
our ($DEFIELE, $defimod, $DEFIUNI,,  $defiabrev
    ,$defiuni, $deficomp, $defiequiv, $defimagn
    ,$palabrasequivV, $palabrasequi)
      = ({}, {}, {}, {}, {}, {}, {}, {}, {}, {});
  #$deficomp      #$plantilla = > # ref a hash de compuestos para C,E,J,L,R
  #$defiabrev     #$plantilla => # ref a hash de abreviaturas para V e I
 
  #$DEFIELE}           # key nombre de elemento, value ref a hash
                               # de datos sobre el elemento 
  #$defimod        # identif. del modelo => ref a hash
  #$DEFIUNI        # codigo de primera parte de nombre de formas=>
                                 # ref a hash de
                               #    unidades y nombres para los 
			       # distintos elementos reales
                         # ejemplo de rama: 5=>{'E' => 'gradoC, temperatura',
  #$defiabrev     # codigo de primera parte de 
                               # nombre de formas=>
                               # ref a hash de abreviaturas para V e I
  #$defiuni
  #$defiequiv     # codigo de primera parte de 
                               # nombre de formas=>
                               # refer a hash de equiv. de abrev
  #$defimagn      # codigo de primera parte de 
                               # nombre de formas=>
                               # refer a hash de magnitudes
  #$palabrasequivV      
  #$palabrasequivI

     # ref. a arrays o hashes para contener atributos de los objetos;
     # el índice es el número de  objeto absoluto para simusol
   
our (@opciones,$opciones); #relativo a llamada a simusol
our @orden_nodos_mod = (4, 2, 0, 6, 7, 8, 1, 3,5); 
    # es el orden correspondiente a
    # sentido horario para el modelo general, la shape de 9 conexiones;
    # el punto de conexion 0 corresponde al 4, el 1 al 2 el ultimo al 5
    # y se trabaja como si siempre se ocuparan las primeras conexiones.
    #los demás modelos deben tener justo el número exacto de conexiones
    # que usen#por lo que no tendra importancia ese orden
#LOLIour %fortranfun = ('DSQRT',1,'DSIN',1,'DCOS',1,'DEXP',1,'DATAN',1
#LOLI                    ,'DABS',1,'DLOG',1,'DLOG10',1,'DMOD',1);
our (%hash_funciones_definidas, %hash_tablas_definidas);
#tablas usadas por un circuito se guardan en $refcirc-{USATAB}

our %codigoStandard=(
    'Image'=>['A','A'],
    'Text'=>['A','A'],
    'Ellipse'=>['A','A'],
    'Box'=>['A','A'],
    'Polygon'=>['A','A'],
    'Arc'=>['x','x'],
    'BezierLine'=>['x','X'],
    'Beziergon'=>['A','A'],
    'Line'=>['l','l'],
    'PolyLine'=>['x','X'],
    'ZigZagLine'=>['X','x']);
    #las ZigZagLine nombran diferente a sus handlers
our %codigovalor=(
    'nodo'=>'N', 
    'nodod'=>'n',
    'Image'=>'A', 
    'Text'=>'A',
    'Ellipse'=>'A',
    'Box'=>'A',
    'Polygon'=>'A',
    'Arc'=>'x',
    'BezierLine'=>'X',
    'Beziergon'=>'A',
    'Line'=>'l',
    'PolyLine'=>'X',
    'ZigZagLine'=>'x',
    'Objet'=>'O',
    'Object'=>'O',
    'modelo'=>'T',
    ''=>'Z'
);
    # en la explicación siguiente handle significa 
    # "enganchable activo": hay
    # que pescarlo precisamente y acercarlo a un punto de conexión para
    # conseguir un enganche. (mientras se trabaja con Dia)
our %quenombre=(
    'J'=>'fuente de corriente',
    'R'=>'resistencia',
    'E'=>'fuente de tensión',
    'C'=>'condensador',
    'N'=>'nodo',
    'n'=>'nodo rep.',
    'A'=>'texto descriptivo o fig. auxiliar',
    'l'=>'rama de conexión con posibles contactos',
    'X'=>'rama de conexión',
    'X'=>'rama tipo ZigZag',
    'V'=>'texto con valores',
    'T'=>'modelo',
    'O'=>'Cuadro',
);
our %nombrepuntos=(
    'PolyLine'=>'poly_points',
    'ZigZagLine'=>'orth_points',
    'Line'=>'conn_endpoints',
    'Arc'=> 'conn_endpoints',
    'BezierLine'=>'bez_points');     
our ($BASEARCHA, $CORTOA, $PROPIOA, $CORTOASINDIA, $PROPIOASINDIA
    , $pwdori);
$CORTOA = '';
our %unist;
abbrev \%unist, qw(minutos horas segundos dias);
#lo anterior define un hash con key: abreviatura y value los dados;
# ejemplo: $unis{se} vale segundos; $unis{'aab'} está indefinido
our %factort = ('segundos' => 1, 'minutos' => 60, 'horas' => 3600, 
                'dias' => 86400, 'hour'=>3600);
our ($unidadtiempo ,$comitiempo, $fintiempo,$origcomitiempo,$origfintiempo) 
        =  ('minuto', 0, 10800, '0', '180 minuto'); 

our %acep_fun;
my @aceptables = qw(sqrt sin cos exp abs log log10 sign mod sinh cosh);
map (do{$acep_fun{$_} = 1; $acep_fun{"d$_"} = 1},@aceptables);
#$acep_fun{qproducto} = 1; $acep_fun{qsuma} = 1;
    #impr_debug(__LINE__.' Glob,%acep_fun',\%acep_fun);
my @extensiones = 
   ('ls1', 'ls2','GNU', 'GPI'
    , 'dirac', 'gra', 'gnu', 'gnu1'  
    , 'res', 'res1', 'simul', 'simul1', 'caj', 'caj1'
    , 'd', 'd1', 'paraplot', 'paraplot1', 'lss1', 'lss11'
    , 'eps','png','ps','for'
    , 'shape', 'sheet', 'autosave','log', 'dump'
    , 'html', 'svg'
);
# son extensiones usadas por simusol con distintos propositos para archivos
# que no serán diagramas
our (%no_ext);
map($no_ext{$_} = 1,@extensiones);

BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(
                $laylista $plantillalista $shapelista
                $codlista $codvalorlista $textolista $lugarlista
                @reflayer $cuantosobj @dirplantiquedan
		%acep_fun %codigoStandard
                %codigo %codigovalor %quenombre 
                $cuallay $nombrelay
		$cualplantilla $nombreplantilla
                $cuantosiconos
		$cualshape $nombreshape 
                $cualelemento $comonombre $nombreelemento
		$comocod $comocodvalor $comootrosnodos
                %nombrepuntos %clasearchivos
                %lay_mod_arch %lay_circ_arch
	        %nombresusados %expr_usadas
	        @nomcirc @nomfile
	        %reffi %refficompl %reffipri $DEFIELE $defimod 
                $DEFIUNI $defiabrev $defiuni $deficomp $defiequiv $defimagn
                $palabrasequivV       
                $palabrasequivI
	        @opciones $opciones
		@orden_nodos_mod
                %hash_funciones_definidas 
 		%hash_tablas_definidas
                %fortranfun
	        %opt_hash %opt_comun 
                %unist %factort
                $unidadtiempo $comitiempo $fintiempo
                $origcomitiempo $origfintiempo		
                $version
                $CAJAS
		$HOMEDIR $INSTALLDIR $SIMUSOLBINDIR $SIMUSOLLIBDIR
		$INSTDIR $LIBDIR $BINDIR
                %numarch %no_ext
                $BASEARCHA $pwdori
                $CORTOA $CORTOASINDIA $PROPIOA $PROPIOASINDIA $PRINCIPAL
		%extension %progr
                &cargar_datos &copiar_datos &borrar_datos 
                &mover_datos &tomar_datos
                &comparar_icono 
                &descripcion_capa
                &descripcion_nombre &descripcion_objeto &descripcion_cuadro
                &descripcion_icono
		&repite_nombre 
                &impr_dat &impr_dat_que
                &impr_datos &impr_obj &impr_ramas &impr_identi
                &impr_cualobjref
                &impr_RESULTADOS &impr_tablas
                &impr_enganches
                &impr_unionesobj
                &impr_opciones
		&controlar_our
		&crear_gnus 
		&comfin &parar1 &porparar1
                &error_progr
                &cajear_capa
       );  
};
END();
# ---------------------------------------------------------------------------
sub comfin{ #uso comfin('com xxxxxx', @_)   o comfin('fin xxxxxx', @_)
  # o comfin('fin xxxxxx', @_,$lisque,$ref,'impr')
  # o comfin('fin xxxxxx',,$lisque,$ref,'impr')
  # 'impr' para que llame a impr_datos con $lisque y $ref
  return ''  unless $debug;
  my @viene = @_; shift @viene;
  my @simplif;

  foreach(@viene) {
      next if not defined $_;
      my $texto = substr($_,0,80);
      my $nuevo = $_;
      if ($texto =~ /^ARRAY\(/) { 
         my @lisundef = @$_; @lisundef = grep(do{not defined $_},@lisundef);
          if(@$_>8) {
             $nuevo = 'ARRAY (' . scalar (@$_) . ')'    
          } elsif (@lisundef) {
             $nuevo = 'ARRAY (' . scalar (@$_) . 'con undef)'
	  } else {
             $nuevo = "[@$_]";
          }
      } elsif ($texto =~ /^HASH\(/) {
       $nuevo = 'HASH (' . scalar (keys (%$_ )) . ')'; 
          if (defined $_->{archivo}) {
              $nuevo .= " - $_->{archivo}: ";   
          } elsif (defined $_->{refcirc} and defined $_->{refcirc}->{archivo}) { 
              $nuevo .= " - $_->{refcirc}->{archivo}: ";
          };
      } elsif ($texto =~ /^SCALAR\(/) {
	  $nuevo = 'SCALAR (' . length($$_) . ')';
      } elsif (@_>2) {
          $nuevo = "/$texto/";
      } else {
          $nuevo = "/$_/";
      };
      push @simplif, $nuevo;
  };
  my ($donde,$comfin);
  if ($_[0] =~ /^\s*(\w+)\s+(\S\w*)/){
     ($donde,$comfin) = ($1,$2);
    if (@_ >3 and defined $_[-1] and defined $_[-2] 
         and $_[-1] eq 'impr' and  $_[-2] =~ /HASH\(/ ) {
      impr_datos("para $comfin pide comfin $donde",$_[-3],$_[-2]);
     };
  };
  eco(" $_[0](" . join(',',@simplif). ')'); #para comfin
  return '';
} #comfin
# ---------------------------------------------------------------------------
sub tomar_datos{
   my ($ref,$que,$nombre,$mensaje) = @_;
   return ($ref->{$que}->{$nombre}, $ref->{"TIP$que"}->{$nombre},
           $ref->{"TIPARG$que"}->{$nombre}, $ref->{"REFARG$que"}->{$nombre}); 
}
# ---------------------------------------------------------------------------
sub cargar_datos{
   comfin('com cargar_datos',@_); 
   my ($ref,$que,$nombre,$valor,$tipo,$tiparg,$refarg,$mensaje) = @_;
   #impr_dat_que($nombre, $que, $mensaje, $ref, 'cg0'); 
   $tipo eq 'n' and defined $ref->{"TIP$que"}->{$nombre} and 
       $ref->{"TIP$que"}->{$nombre} =~ /[afpqx]/  and do{
           $ref->{"VIEJO$que"}->{$nombre} = $ref->{$que}->{$nombre};
           $ref->{"TIPVIEJO$que"}->{$nombre} = $ref->{"TIP$que"}->{$nombre};
       };
   $ref->{$que}->{$nombre} = $valor;
   $ref->{"TIP$que"}->{$nombre} = $tipo;
   $ref->{"TIPARG$que"}->{$nombre} = $tiparg;
   $ref->{"REFARG$que"}->{$nombre}= $refarg;  
   #impr_dat_que($nombre, $que, $mensaje, $ref, 'cg1');
}   
# ---------------------------------------------------------------------------
sub copiar_datos{
   my ($refo, $queo, $nombreo, $refd, $qued, $nombred, $mensaje) = @_;
   #impr_dat_que($nombreo, $queo, "$mensaje", $refo, 'cp0'); 
  impr_datos(__LINE__.' Glob', ['DATOS','PARAMETROS'], $refo);

   my $tipoo = $refo->{"TIP$queo"}->{$nombreo};
   my $tipod = $refd->{"TIP$qued"}->{$nombred};
   defined $tipoo and $tipoo eq 'n' and defined $tipod and $tipod =~ /[afpqx]/
       and $refd->{"VIEJO$qued"}->{$nombred} = $refd->{$qued}->{$nombred};
   $refd->{$qued}->{$nombred} = $refo->{$queo}->{$nombreo};

   $refd->{"TIP$qued"}->{$nombred} = $refo->{"TIP$queo"}->{$nombreo};
   $refd->{"TIPARG$qued"}->{$nombred} = $refo->{"TIPARG$queo"}->{$nombreo};
   $refd->{"REFARG$qued"}->{$nombred} = $refo->{"REFARG$queo"}->{$nombreo};
   my $agre = substr($queo,0,3). "-$nombreo";
   #impr_dat_que($nombred, $qued, "$mensaje($agre)", $refd, 'cp1'); 
}   
# ---------------------------------------------------------------------------
sub borrar_datos{
   #con $modo verdadero no se registra como borrado el parametro
   my ($ref,$que,$nombre,$modo,$mensaje) = @_;
   if ($que eq 'PARAMETROS') {
       if (not $modo  and not $ref->{parametroscreados}->{$nombre}
               and defined $ref->{PARAMETROS}->{$nombre}) {
           copiar_datos($ref,'PARAMETROS',$nombre,$ref,'PARBORR',$nombre
			,__LINE__,' Glob ');
       };
   };
   #impr_dat_que($nombre, $que, $mensaje, $ref, 'br'); 
   delete $ref->{$que}->{$nombre};
   delete $ref->{"TIP$que"}->{$nombre};
   delete $ref->{"TIPARG$que"}->{$nombre};
   delete $ref->{"REFARG$que"}->{$nombre}; 
}   
# ---------------------------------------------------------------------------
sub mover_datos{
   #se confia que nunca el nombre descartado haya entrado de nuevo
   my ($refo, $queo, $nombreo,$refd, $qued, $nombred,$mensaje) = @_;
   return if $refo eq $refd and $queo eq $qued and $nombreo eq $nombred;
   $refd->{$qued}->{$nombred} = $refo->{$queo}->{$nombreo};
   $refd->{"TIP$qued"}->{$nombred} = $refo->{"TIP$queo"}->{$nombreo};
   $refd->{"TIPARG$qued"}->{$nombred} = $refo->{"TIPARG$queo"}->{$nombreo};
   $refd->{"REFARG$qued"}->{$nombred} = $refo->{"REFARG$queo"}->{$nombreo};
   #impr_dat_que($nombreo, $queo, $mensaje , $refo, 'bmv'); 
   delete $refo->{$queo}->{$nombreo};
   delete $refo->{"TIP$queo"}->{$nombreo};
   delete $refo->{"TIPARG$queo"}->{$nombreo}; 
   delete $refo->{"REFARG$queo"}->{$nombreo}; 
   my $agre = substr($queo,0,3). "-$nombreo";
   #impr_dat_que($nombred, $qued, "$mensaje$agre", $refd, 'mv'); 
}   
#----------------------------------------------------------------------------
sub comparar_icono{
  my ($ref,$descrig,$rh) = @_;
  my $rhv = $ref->{$descrig};my $coderror = 0; 
  if (defined $rhv->{nombre}) {
      foreach my $tema ('nombre','cod','codvalor') {
          $rhv->{$tema} eq $rh->{$tema} or
             return ($tema, $rhv->{$tema}, $rh->{$tema});
      };
  };
  foreach my $tema ('nombre','cod','codvalor') {
      $rhv->{$tema} =  $rh->{$tema};
  };
  return '';
}
#----------------------------------------------------------------------------
sub crear_gnus{
   my $BASEARCH = $_[0];
   my $dire = $BASEARCH . 'gnus';
   -e $dire and not -d $dire and do{
       print '=' x 70,"
   ======  Estoy por borrar un archivo de nombre $dire; de otro modo termino;
   ======  Borro $dire (s/n)? ";
       my $resp = <STDIN>;
       $resp =~ /n/i 
         and die "Con un archivo \"gnus\" en $BASEARCH no puedo trabajar\n";
       system "rm $dire";
    };
    system "mkdir $dire"  and porparar1(254,0,
         " Simusol no puede trabajar sin permisos para escribir archivos");
} # crear_gnus
# ---------------------------------------------------------------------------
sub descripcion_nombre{
# describe a un objeto dado por su identificacion $iden "para sceptre",
# en el hash referido por $cualobj
  #comfin ('com descripcion_nombre', @_");
  my ($iden,$cualobj) = @_; 
# REVISAR
  my ($cod,$texto) =  ($iden =~ /^(.)(.*)/);  
  my $idenn = $iden;
  if ($cod eq 'O') {$idenn  = $texto};
  my $listadescrip=''; 
  if  (not defined $cualobj->{$iden}) {
      $listadescrip .= "\n        No hay datos para describir a $iden\n";
  } else {
      my @lista = @{$cualobj->{$iden}};
      
      for (my $i = 0; $i < @lista; $i ++) {
        my $obj = $lista [$i]; 
        $listadescrip .= "  $idenn:   " . descripcion_objeto($obj) ."\n" ;
     };
  }; 
  #comfin ('fin descripcion_nombre');
  return $listadescrip;
} #descripcion_nombre
# ---------------------------------------------------------------------------
sub descripcion_objeto{
  #describe a un objeto dado por su numero de objeto que le toco
  #comfin ('com descripcion_objeto', @_);
  my $obj=$_[0];
  my ($cod,$codvalor,$texto) 
      = ($codlista->[$obj],$codvalorlista->[$obj], $textolista->[$obj]);
  #impr_debug(__LINE__.' Glob desc._objeto ',[$cod,$codvalor,$texto]);
  if ($codlista->[$obj] ne 'O') { #para 'O' se usa descrip_cuadro
     $texto  = $cod . $texto};
     my ($capa,$lug);
     my ($pl,$sh) =($plantillalista->[$obj], $shapelista->[$obj]);
     my $nombre= '"'.$nombreshape->[$sh].'"';
     if (defined $comonombre->{$pl .'c'. $sh}) {
          $nombre .= ' '. $comonombre->{$pl .'c' . $sh}. " $texto";
     } elsif (defined $quenombre{$cod}) {
          $nombre .= " $quenombre{$cod} $texto";
     };
     if ($lugarlista->[$obj]) {
        $lug = $lugarlista->[$obj]; 
        $lug =~ s/\s*$//; $lug =~ s/^\s*//; 
     } else {
       $lug = '??'
     }; 
     if (defined $laylista->[$obj]  and $nombrelay->[$laylista->[$obj]]) {
        $capa = $nombrelay->[$laylista->[$obj]];
        $capa =~ s/.*\(0 \- (.+)\)/$1/; 
        $capa =~ s/^\s*(.+)/$1/;$capa =~ s/\s*$//;
     }  else {$capa = '??';
  };  
  #comfin ('fin descripcion_objeto');
  return "$nombre (en $lug, $capa)";
}
# ---------------------------------------------------------------------------
sub descripcion_cuadro {
    my $numobj = $_[0];
    $numobj =~ s/\#numobj(.+)/$1/;
    my $lug = $lugarlista->[$numobj]; $lug =~ s/\s*$//;
    my $il = $laylista->[$numobj];
    my $capa = descripcion_capa($laylista->[$numobj]);
    return "cuadro $textolista->[$numobj] en $lug-($nombrelay->[$il])";
}
# ---------------------------------------------------------------------------
sub descripcion_icono{
  # descripcion (el nombre de la shape) de la forma dada por el $plcshape
  # que le toco 
   my $plcshape = $_[0];
   my ($pl,$shape) = $plcshape =~ /(\d+)c(\d+)/;
   return $nombreplantilla->[$pl] .' - ' . $nombreshape->[$shape];
}
# ---------------------------------------------------------------------------
sub descripcion_capa{
   my $il = $_[0];
   if (defined $nombrelay->[$il]) {
      return "capa $il: $nombrelay->[$il]";
   } else {
      return "capa $il";
   };    
}
# ---------------------------------------------------------------------------
sub repite_nombre{ 
   my ($iden,@listita)=@_;
   print 
    "El identificador $iden está repetido para los elementos  en: \n     ";
   map (do {print "$lugarlista->[$_]  "},@listita);print "\n";
   $avisosgrav++
}
# ---------------------------------------------------------------------------
sub impr_cualobjref{
   return unless $opt_hash{d};
   my ($mensaje,@lisref) = @_; 
   #my $refcirc; 
   my %cosa; 
   imprhashrenglon(__LINE__." Glob $mensaje ", %{$lisref[0]});
   if (defined $lisref[0]->{refcirc}) {
      $cosa{$lisref[0]} = 'capa ';
      $cosa{$lisref[0]->{refcirc}} = 'circuito';
      push (@lisref,$lisref[0]->{refcirc});
   } else {
      $cosa{$lisref[0]} = 'no es capa ';
   };
   foreach my $ref (@lisref) {    
     my @liscuales = keys %{$ref};
     @liscuales = grep (/^cualobj/,@liscuales);
     foreach my $cualque (@liscuales) {
       print STDERR "...... $mensaje $cosa{$ref}$cualque\n";
       my @lisobjetos = keys %{$ref->{$cualque}};
       foreach (@lisobjetos) {
           print STDERR "$_=> [ " .  
                  join (' ', @{$ref->{$cualque}->{$_}}) . " ]\n";
       };
     };
   };
   print "fin impr_cualobjref $mensaje\n";   
}
# ---------------------------------------------------------------------------
sub impr_identi{
   # sólo se usa para depurar
   my ($mensaje,$refcirc) = @_; 
   return unless $opt_hash{d};
   print STDERR "----------------------- com Glob impr_identi: $mensaje
                   a pedido de archivo $refcirc->{CORTO}\n";
   impr_debug(__LINE__.' Glob cuallay',Dumper $cuallay);
   impr_debug(__LINE__.' Glob cualplantilla', Dumper $cualplantilla);
   impr_debug(__LINE__.' Glob cualshape', Dumper $cualshape);
   impr_debug(__LINE__.' Glob comonombre', Dumper $comonombre);
   impr_debug(__LINE__.' Glob comocod', Dumper $comocod);
   impr_debug(__LINE__.' Glob comocodvalor', Dumper $comocodvalor);
   impr_obj($mensaje,'[RJCEZT]',$refcirc->{capas});
   print "                   a pedido de archivo $refcirc->{CORTO}
----------------------- fin Glob impr_identi: $mensaje\n";
}
# --------------------------------------------------------------------------
sub impr_dat_que{
  return unless $opt_hash{d};
  my ($nombre,$que,$mensaje,$ref,$clave) = @_; 
  defined $mensaje or $mensaje = '';
  my $form = "i.d:%3s%6s=>%1s|%6s|%24s|%2s %13s\n";    
  if (defined $ref->{$que}->{$nombre}) {
      my ($dato,$tipdato,$tipargdato,$refargdato) 
            = ($ref->{$que}->{$nombre}
               ,$ref->{"TIP$que"}->{$nombre}
               ,$ref->{"TIPARG$que"}->{$nombre}
               ,$ref->{"REFARG$que"}->{$nombre});
      not defined $tipdato and $tipdato = '';      
      not defined $tipargdato and $tipargdato ='';
      my $largo = length($dato); $largo < 55 and $largo = 24;
      $dato = substr($dato . ' ' x 50,0,$largo);
      printf STDERR $form, $clave, $nombre,
         $tipdato, $tipargdato, $dato ,$que, $mensaje;
      print STDERR  "i.d:$clave $nombre REFARG            ", __LINE__. 'Glob '
                   ,"@$refargdato","\n"
                 if defined $refargdato and $refargdato =~ /^ARRAY/; 
  } else {
      printf STDERR $form,$clave,"$nombre",'','','No está'
         ,'','',$mensaje; 
  };
  return;
   
} #impr_dat_que
# --------------------------------------------------------------------------
sub impr_dat{
  # imprime datos para una sola posible variable del sceptre
  # sólo se usa para depurar
  return unless $opt_hash{d};
  my ($nombre,$mensaje,$ref,$clave) = @_; my $que;
  my @ternas;
  for my $posque ('DATOS','PARAMETROS') {
      if (defined $ref->{$posque} and defined $ref->{$posque}->{$nombre}) {
           push @ternas,[$posque,$ref->{$posque}->{$nombre},$nombre];  
           last
      }
  };
  my $form = "i.d:%3s%6s=>%1s|%6s|%24s|%2s %13s\n";    
  $mensaje or $mensaje = '??';
  if (@ternas == 0) { 
      if (defined $ref->{cualobjtextonodo}->{$nombre}) {
          printf STDERR $form,$clave,$nombre,'','','Nodo','',$mensaje;
      };
      my $pre = '';
      if ($nombre =~ s/^([VJ])//) {
          $pre = $1; my $dato = $ref->{DATOS}->{$nombre};
          if (defined $dato){
              push @ternas, ['DATOS',$dato,$nombre];
          } else {
	      printf STDERR $form,$clave,"$pre$nombre",'','','No está'
                          ,'','',$mensaje; 
              return;
          };
      } elsif ($nombre =~ s/^(TEMP)\s*//i) {
	  $pre = $1;
          my $datoT = $ref->{TEMP}->{$nombre};
          my $datot=  $ref->{temp}->{$nombre}; 
          if (defined $datoT){
              push @ternas, ['TEMP',$datoT,$nombre]
          } elsif (defined $datot) {
              push @ternas, ['temp',$datot,$nombre]
          } else {
	      printf STDERR $form,$clave,"$pre$nombre",'','','No está'
                  ,'',$mensaje; 
              return;     
          };              
     } elsif (defined $ref->{cualobjnoigno}->{$nombre}) {
          my $lugar = $lugarlista->[$ref->{cualobjnoigno}->{$nombre}->[0]];
	  printf STDERR $form,$clave, $nombre,'','Es el objeto en $lugar?',''
                  ,'', $mensaje;
          return;                   
     } else {
	  printf STDERR $form,$clave, $nombre,'','','No se encuentra',''
                          , $mensaje;
          return;
     }     
  };
  foreach my $terna (@ternas) {
      my ($que, $dato, $nombre) = @$terna;
      my $largo = length($dato); $largo < 55 and $largo = 24;
      $dato = substr($dato . ' ' x 50,0,$largo);
      my $tipdato = ($ref->{"TIP$que"}->{$nombre} or '');
      my $tipargdato = ($ref->{"TIPARG$que"}->{$nombre} or '');
      my $usapar  = ($ref->{'USAPAR'}->{$nombre} or '');
      $usapar and $usapar = 'par '. $usapar or 
            $usapar = $que; 
      # solo util en PARAMETROS
      printf STDERR $form, $clave, $nombre, 
                $tipdato, $tipargdato, $dato ,$usapar,$mensaje;
  };
  return;	  
}# impr_dat
# ---------------------------------------------------------------------------
sub impr_datos{
  # sólo se usa para depurar
  return unless $opt_hash{d};
  my ($ident, $lisque, $ref, $nombre) = (@_,'');
  return unless $ref ne ''; 
  $nombre or $nombre = $ref->{nombrecirc};
  defined $nombre or $nombre = $ref->{CORTOELE};
  defined $nombre or $nombre = $ref->{CORTO};
  defined $nombre or $nombre = 'sin nombre';
  print STDERR "    empieza impr_datos. @$lisque\n    ($ident) 
                     para $nombre ",'=' x 15,"\n"; 
  my ($para,$resu,$funci);
  foreach my $que (@$lisque) { 
      my @lista = ();
      @lista = keys %{$ref->{"TIP$que"}} if defined $ref->{"TIP$que"};
      @lista = keys %{$ref->{$que}} if defined $ref->{$que} and not @lista;
      @lista or next;
      my $otro;
      $que eq 'DATOS' and $otro = 'uni'
	  or $que eq 'PARAMETROS' and $otro = 'USAPAR';

      print STDERR
        "  =>(TIP$que|TIPARG$que|     $que             |............)\n";
      foreach (sort @lista) {
          my $dato = $ref->{$que}->{$_};
	  $dato = 'no definido' unless defined $dato;
          my $largo = length($dato); 
          my $sobra = $largo -24;my $dato2='';
          $sobra >0 and $dato2 = substr($dato,24,$largo);
          $largo < 55 and $largo = 24;
          $dato = substr($dato . ' ' x 50,0,$largo);
          my $tipdato = ($ref->{"TIP$que"}->{$_} or '');
          my $tipargdato = ($ref->{"TIPARG$que"}->{$_} or '');
          my $elotro  = '';
          defined $otro and defined $ref->{$otro} 
              and defined $ref->{$otro}->{$_}
              and $elotro = $ref->{$otro}->{$_};
	  defined $ref->{"REFARG$que"}->{$_} 
             and $elotro = "REFARG $ref->{'REFARG'.$que}->{$_}"
          or  $elotro = "REFARG no hay" ; 
          printf STDERR "%10s=>%1s|%6s|%24s|%2s\n" 
                 ,$_, $tipdato, $tipargdato, 
              $dato ,$elotro;
          $sobra >0 and printf STDERR "%10s=>%1s|%6s|%24s|%2s\n"
	      ,'','','',$dato2,'';
      };
      my $texto ='';
      if ($que eq 'PARAMETROS' and @lista) {
          $texto .= '   Glob parametroscreados: '.
                   join (' ', keys %{$ref->{parametroscreados}})."\n"
            if defined $ref->{parametroscreados};
          $texto .= '   Glob parametrossustituidos; '.
                   join (' ', keys %{$ref->{parametrossustituidos}})."\n"
            if defined $ref->{parametrossustituidos};
          $texto .= hashrenglon('   Glob valuespar: ', %{$ref->{valuespar}})
            if defined $ref->{valuespar};
          $texto .= '   Glob parámetros usados: '.
        	    join (' ', keys %{$ref->{USAPAR}})."\n"
           if defined $ref->{USAPAR} and scalar  %{$ref->{USAPAR}}; 
      } elsif ($que eq 'RESULTADOS' or $que eq 'temp') {
          $texto .= hashrenglon('   Glob TEMP ', %{$ref->{TEMP}});
          $texto .= hashrenglon('   Glob temp ', %{$ref->{temp}});
          $texto .= 'listapedidos ' . "@{$ref->{listapedidos}}\n" 
	      if $ref->{listapedidos};
      } elsif ($que eq 'FUNCIONES' and @lista) {
	  $texto .= hashrenglon('   Glob USAFUN',%{$ref->{USAFUN}});
	  $texto .= hashrenglon('   Glob FUNUSAFUN',%{$ref->{FUNUSAFUN}});
      }
      print STDERR $texto;
  }; # #que
  print STDERR  "impr_datos @$lisque, ($ident termina)
                     para $nombre ",'=' x 15,"\n  ",'=' x 60,"\n";  
}#impr_datos
# ---------------------------------------------------------------------------
sub impr_ramas{
  # sólo se usa para depurar
  return unless $opt_hash{d};
  my ($mensaje,$reflay) = @_; my $sinnada = ''; 
  print STDERR 
 "   Glob impr_ramas $mensaje; 
                 $reflay->{refcirc}->{archivo};capa $reflay->{capa}\n";
  my @listakeys = sort grep(/^lisramas/ , keys %$reflay);
  foreach my $key (@listakeys) {
      my @lista; my $marca ;
      next if $key eq 'lisramascrudas' and @listakeys > 1; 
      if ($key ne 'lisramaspar') {
          @lista = @{$reflay->{$key}}; $marca = ' ';
      } else {
          my @listapares = @{$reflay->{$key}};
          map (push(@lista, @$_), @listapares); 
          $marca ='p';
      };
      $reflay->{$key} !~ /^ARRAY/ and next;
      if (@lista) {
          print STDERR scalar @lista, " ramas en $key\n";           
          foreach my $rama (@lista) {
	      my $codrama = $codlista->[$rama];
              foreach my $enganche (@{$reflay->{conexiones}->{$rama}}) {
                  my ($ramai, $handle, $lugar, $to,$connection) =
                  @$enganche{'rama','handle','lugar', 'to','connection',};
                  $to or next;
                  my $cod = $codlista->[$to]; my $texto = $textolista->[$to];
                  printf STDERR 
                  "Para rama  $marca%4i cod%2s: rama%4i, h%2i,%16s," . 
                                " objeto%4i, c%2i, %1s%1s\n",
                  $rama, $codrama, $ramai, $handle,
                  $lugar,$to,$connection,$cod,$texto; 
	     };
         };
      } else {
	  $sinnada .= " $key";
      };
  };
  print STDERR " Conjuntos sin ramas:
          $sinnada\n";
  return;
}
# ---------------------------------------------------------------------------
sub impr_unionesobj{
   comfin('comfin impr_unionesobj',@_);
   my ($mensaje,$reflay) = @_;
   return unless $opt_hash{d};
   my $refun = $reflay->{unionesobj};
   not defined $refun and do{print STDERR "$mensaje : no hay nada"; return};
   foreach my $obj(sort keys %$refun) {
       my $tira;
       $tira =  "@{$refun->{$obj}}"; 
       printf STDERR "%4i %20s %7s  %1s\n", $obj, $lugarlista->[$obj], 
              "$codlista->[$obj]$textolista->[$obj]", $tira;
   };
}    
# ---------------------------------------------------------------------------
sub impr_obj{ 
  # datos de objetos cuyo numero esta en la lista y cumplen r.e.   
  # sólo se usa para depurar
  return unless $opt_hash{d};
  my ($mens,$reg,$lislay,$lisobj) = @_;
  # $mens mensaje; $reg expresión regular de cod. de objetos
  # $lislay ref. a lista de num. de layers
  # $lisobj ref. a lista de num. deobjetos; sera seleccionada bajo $reg  
  # $refcirc referencia a circuito con la informacion
  defined $reg or $reg = '[RLCEJTt]';
  defined $lislay or $lislay = [0 .. scalar @reflayer -1];
  defined $lisobj or $lisobj = [0 .. (scalar @$codlista -1)];
  print STDERR "   Glob com. impr_obj: $mens" ,'=' x 15,"\n";
  my ($uni,$DATOS,$INICIALES) = ('','','');
  foreach my $il (@$lislay) {
      if ($il > @$laylista -1) {
          print STDERR "capa $il inexistente\n";
	  next
      } else {
          my $reflay = $reflayer[$il];
	  my $refcirc = $reflayer[$il]->{refcirc};
          print STDERR "...........", descripcion_capa($il)
                  ," expr_reg  $reg \n";
          defined $reflay and
          do {$uni = $refcirc->{uni}; 
              $DATOS = $refcirc->{DATOS}; 
              $INICIALES = $refcirc->{INICIALES};
          };	
          my @lisobjsel = grep(
	          do{ ($codlista->[$_] =~ /$reg/) and $laylista->[$_] == $il}
	                     , @$lisobj);
         if (@lisobjsel) { 
                printf STDERR "%3s %13s %4s %7s %3s %15s %8s %20s\n" 
       ,'#', 'nombre   ' , 'iden','placsha','c.v','lugar       ','uni','datos';
	 } else {
             print STDERR "   No hay objetos de esa clase $reg\n";
             my @lisobjcod = grep ($codlista->[$_] =~ /$reg/,@$lisobj);
             my @lisobjlay = grep ($laylista->[$_] == $il,@$lisobj);
         };
          foreach my $ij (@lisobjsel) {
              my $iden = $codlista->[$ij] . $textolista->[$ij]; 
              my $plantillacshape = 
        	    $plantillalista->[$ij]. 'c' .$shapelista->[$ij];
              my $identif = $comonombre->{$plantillacshape};
	      defined $identif or $identif
                  = $nombreshape->[$shapelista->[$ij]];
              printf STDERR "%3s %13s %5s %6s %3s %15s"
                ,$ij, substr($identif . '.' x 9,0,10) . '...'
	        , substr($iden,0,6), $plantillacshape
	                , $codvalorlista->[$ij], $lugarlista->[$ij]; 
              my ($unisiden,$datosiden,$inicialesiden);
              $uni  and do{$unisiden = $uni->{$iden}}; 
	      $DATOS and do{$datosiden = $DATOS->{$iden}};
              $INICIALES and do{$inicialesiden = $INICIALES->{'V' . $iden}};
              defined $unisiden or $unisiden = 'nodef';
              defined $datosiden or
	      do {$datosiden = 'nodef';
	      };
              defined $inicialesiden or $inicialesiden = '---';
              printf STDERR"%6s %20s %6s\n"
                      , $unisiden,$datosiden,$inicialesiden; 
          };#foreach $ij
      }; #else; sí hay capa
  };#for $il
  print STDERR "\n",'=' x 15, "\n";
  #imprhash('temp ',%{$refcirc->{temp}});		   
}; #impr_obj
# ---------------------------------------------------------------------------
sub impr_resultados{
   # impr( '   Glob impr_obj ',@$lislay,'sepa',@$lisobj);
   return unless $opt_hash{d};
   my ($mensaje, $ref) = @_;
   print STDERR '   Glob impr_resultados',"\n";
   impr_datos($mensaje, ['RESULTADOS','TALCUALRESULTADOS','temp'], $ref);
   impr_debug ("$mensaje indicebueno", $ref->{indicebueno});
   impr_debug($mensaje. ' lisnum ',  Dumper $ref->{lisnum});
   impr_debug($mensaje. ' listalisnum ',  $ref->{listalisnum});
   impr_debug($mensaje. ' lisoutputussceptre ',$ref->{lisoutputssceptre});
   impr_debug($mensaje. ' lispropiasvars', $ref->{lispropiasvars});
   impr_debug($mensaje. ' lismagnitudes', $ref->{lismagnitudes});
   impr_debug($mensaje. ' lisunidades', $ref->{lisunidades});
   impr_debug($mensaje. ' lisresultadosmalos', $ref->{lisresultadosmalos});
   impr_debug($mensaje. ' lisrepetidos', $ref->{lisrepetidos});
}
# ---------------------------------------------------------------------------
sub impr_tablas{
    return unless $opt_hash{d};
    my ($mensaje,$ref) = @_;
    my @listablas = sort keys %hash_tablas_definidas;
    impr_debug(__LINE__.' Glob LOLITA @listablas',\@listablas);
    print STDERR "com impr_tablas     $mensaje\n";
    foreach my $idtabla (@listablas) {
        print STDERR "---------------    tabla $idtabla", 
        "    definida en $ref->{defiTABLAS}->{$idtabla}->{archivo}\n";
        print STDERR "     del archivo $ref->{archivoTABLAS}->{$idtabla}\n"
            if defined $ref->{archivoTABLAS}->{$idtabla};
        my @lista; my $reflista = $ref->{textodefiTABLAS}->{$idtabla};
        if (defined $reflista) {
              print STDERR '        modificadores: '
                  , join ("\n            ",@$reflista)
                  ,"\n        ----------\n";
        }; 
        print STDERR 'cuantas abscisas: ',
                     scalar @{$ref->{absTABLAS}->{$idtabla}},
                     '    ordenadas: ',
                     scalar @{$ref->{ordTABLAS}->{$idtabla}},"\n";
        print STDERR 'primera ',"@{$ref->{priTABLAS}->{$idtabla}}; " .
                       $ref->{absTABLAS}->{$idtabla}->
                          [$ref->{priTABLAS}->{$idtabla}->[0]],"\n";
        print STDERR 'ultima ', "@{$ref->{ultTABLAS}->{$idtabla}}; " .
                       $ref->{absTABLAS}->{$idtabla}->
                         [$ref->{ultTABLAS}->{$idtabla}->[-1]],"\n";
    };
    print STDERR "---------- fin impr_tablas $mensaje\n";
}# impr_tablas
# ---------------------------------------------------------------------------
sub impr_enganches{
  comfin('com impr_enganches', @_);
  return unless $opt_hash{d};
  # imprime los enganches de la rama dada por su numero de objeto
  # y los identificadores de los objetos enganchados
  return unless $opt_hash{d};
  my ($mensaje,$rama) = @_;
  my $reflay = $reflayer[$laylista->[$rama]];
  my @lista = @{$reflay->{conexiones}->{$rama}};
  #@lista = grep($_->{rama} == $rama, @lista); 
  #impr_debug($mensaje," Enganches rama $rama"); 
  foreach my $enganche (@lista) {
      my ($rama, $handle,$lugar, $to,$connection) =
          @$enganche{'rama','handle','lugar', 'to','connection'};
      if ($lugar =~ /HASH/) {$lugar = $lugar->{val}};
      my $cod = $codlista->[$to]; my $texto = $textolista->[$to];
      printf STDERR "rama%4i, h%2i,  %20s, objeto%4i, c%2i, %1s%1s\n",
      $rama, $handle,$lugar,$to,$connection,$cod,$texto; 
  };
  comfin('fin impr_enganches', @_);
} # impr_enganches
# ---------------------------------------------------------------------------
sub impr_opciones{
    my ($mensaje) = (@_,'');
    print STDERR  "$mensaje opciones ", Dumper \%opt_hash;
}
# ---------------------------------------------------------------------------
sub controlar_our{# se usa sin argumentos
   #solo se esta usando desde este modulo; pero esta disponible para todos
   #modificada para .....
   #sólo para depurar
   print STDERR "Los 7 largos deben ser todos iguales  ";
   map (do{print STDERR ( ' ' . scalar @$_ ,' ')},
          ($laylista, $plantillalista , $shapelista, $codlista,
	   $codvalorlista, $textolista, $lugarlista));
   print STDERR "\n";
   foreach my $cosa ($laylista, $plantillalista , $shapelista, $codlista,
		     $codvalorlista, $textolista, $lugarlista) {
       foreach (@$cosa) {
           print " $_";
           $cosa eq $textolista and print "\n"; 
       };
       print "\n";
   };
}
# ---------------------------------------------------------------------------
sub cajear_capa{
  comfin('com cajear_capa',@_); 
  my ($reflay) = @_;
  my $nombre = $nombrelay->[$reflay->{ilayer}];
  my $PROPIOSINDIA = $reflay->{PROPIOSINDIA};
  my $CORTOSINDIA = $reflay->{CORTOSINDIA};
  open CAJ, ">>$CORTOSINDIA.caj";
  print CAJ "# capa ", $nombre,"\n";
  foreach my $key (keys %{$reflay->{refvalores}}) {
     foreach my $num (keys %{$reflay->{refvalores}->{$key}}) {
          print CAJ ' 'x10, "Cuadro $key\n";
          print CAJ join ("\n",@{$reflay->{refvalores}->{$key}->{$num}}),"\n";
      };
  };
  close CAJ;
  comfin('fin cajear_capa'); 
}
# ---------------------------------------------------------------------------
sub porparar1{
  # lo usan subrutinas llamadas por simusol1.pl, relativas a 
  # definicion de formulas o modelos para asignar errores a archivos
  # luego se debe abandonar el tratamiento del archivo correspondiente
  # y pone en 0 el cont. de err. graves 
  comfin('com porparar1',@_);
  my ($coderr, $ref, $mensaje) = @_;
  if ($mensaje) {
      if ($coderr >2) {avgrav($mensaje)} else { explic($mensaje)};
  }
  $reffi{$CORTOA}->{errorparar} = $coderr;
  if ($coderr eq 0) {
     system "rm $CORTOASINDIA.lss1 2>/dev/null";
  };    
  #$avisosgrav = 1 if  ($avisosgrav == 0 and $coderr >2);
  # al final lo lleva a 0
  #impr_debug(__LINE__.' Glob $ref,  argumento de porparar ', $ref); 
  if ($ref eq '0') {
      $ref = $reffi{$CORTOA};
      defined $ref or error_progr(0,__LINE__.' Glob');   
  };
  if ($ref ne '0') {
      my $refcirc = $ref->{refcirc};
      defined $refcirc and # era una capa asignada a un circuito
         $ref = $refcirc; 
  }; 
  #defined $CORTO or 
  #do {$CORTO = $ref->{CORTO};
  #    $CORTOSINDIA = $ref->{CORTOSINDIA}
  #};
  #impr_debug(__LINE__.' Glob $ref', $ref);
  $ref->{errores} += $avisosgrav;
  $avisosgrav = 0;
  comfin('fin  porparar1');
  #return $coderr;
} #porparar1

# --------------------------------------------------------------------------
sub parar1{
    comfin('comfin parar1',@_);
    # $mensaje se usa para errores detectados por simusol1.pl,
    # que aun no se comunicaron;
    # otros se han comunicado por avgrav,... or porparar 
    # el codigo sera 0 (sin error para el principal) 
    # o el numero del exit
    # $archivo, si se da, es el nombre corto
    # $archivo o $mensaje $refcircuito deben estar presentes 
    #impr_debug(__LINE__.' Glob reffi ', \%reffi);
    my ($codigo,$refcircuito,$mensaje,$archivo)
           = (@_,'','');#a veces se usa sin el tercer y cuarto argumentos  
    if ($refcircuito eq '0' and not $archivo) {
        print "$mensaje\n";
        print LSS1 "codigo s1: $_[0]\n"; 
        exit $codigo;
    } elsif ($archivo) { 
        $refcircuito = $reffi{$archivo}; 
    }; 
    my ($CORTO, ,$CORTOSINDIA, $PROPIO, $PROPIOSINDIA, $clase)
	= @$refcircuito{'CORTO', , 'CORTOSINDIA', 'PROPIO', 'PROPIOSINDIA'
                      , 'clasearch'};
    $archivo = $CORTO; 
    impr_datos(__LINE__.' Glob',['PARBORR'],$refcircuito);
    my @parborr = sort keys %{$refcircuito->{PARBORR}};
    if (@parborr) {
        open PARAM, ">$CORTOSINDIA.par";
        print PARAM  '#'.'-' x 10 
	    ." Parámetros o elementos sin influencia en los calculos\n";
        print PARAM  "#    de Sceptre, o ya sustituidos en $PROPIOSINDIA.d\n";
        foreach (sort @parborr) {
           print PARAM "$_ = $refcircuito->{PARBORR}->{$_}\n";
        };
        close PARAM;
        my $cuantos = scalar @parborr;
        mensaje( 
        "Hay $cuantos parámetros sin influencia en los cáculos de Sceptre o 
         ya sustituidos; verlos en $PROPIOSINDIA.par");
        explic " ($CORTOSINDIA.par) " if $PROPIO ne $CORTO;
    };
    if ($codigo > 4 and $mensaje) {
        if ($avisosgrav) {explic($mensaje)} else {avgrav($mensaje)};
    };
    my $SI = 'SI';
    if ($codigo <5) {$SI = 'NO';};
    explic("... $progname $SI detectó errores graves en: $archivo ($clase)\n");
    $reffi{$CORTO}->{errores} = 1 if $codigo > 2;
    if ($refcircuito ne '0' and $clase ne 'elementos') {
        my $BASE = $refcircuito->{BASEARCH};
        foreach my $arch (keys %clasearchivos) {
            my $clase = $clasearchivos{$arch}; 
            my $archm = $arch;
            if ($arch !~ /^\//) {
                $archm =$GlobalesSimusol::pwdori . $arch;
            };
            my ($basearch,$propio,$corto,$propiosindia,$cortosindia) 
                = relativizar($archm,$BASE);
            next if $corto eq $CORTOA;
            my $consin = " sin";
	    if ($reffi{$arch}->{errores}) {
                $consin = " con";   
            };       
            mensaje(" $corto: ($clase)$consin errores");
        };#foreach $arch
    };
    if ($codigo) {
          explic('       no hay circuito para simular');
    } else {    
          explic(" $archivo: se puede intentar simularlo");  
    }; 
    
    open CAJ, ">$CORTOSINDIA.caj";
    print CAJ 
        "#    Archivo $PROPIOSINDIA.caj   preparado por simusol1.pl\n";
    if (defined $CAJAS->{$CORTO}) {
         print CAJ "$CAJAS->{$CORTO}\n";   
    } else {
         print CAJ "Nada para poner aquí\n";   
    }
    close CAJ;
    foreach my $keysindia (keys %{$LSS1}) {
        $keysindia =~ /\s/ and error_progr(0,__LINE__.' Glob');
        my $refc = $reffi{$keysindia};
        my $cod = $refc->{errorparar};
        next if defined $cod and $cod eq 0; 
        # significa que no corresponde archivo .lss1 
        #impr_debug(__LINE__.' Glob $CORTOA,$keysindia,$cod'
        #      ,[$CORTOA, $keysindia,$cod]); 
        my $texto = join("\n",@{$LSS1->{$keysindia}}) . "\n";
        open LSS1, ">>$keysindia.lss1";
        print LSS1 $texto;
    };
    mensaje ("codigo s1: $_[0]"); close LSS1;

    exit $codigo; 
}; #parar1 
# ---------------------------------------------------------------------------
1
