# son ayudas para el programador; algunas para dar informacion al programador;
# otras para que sea mas facil programar ayudas para los usuarios
package Simusol::Ayudas;
use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys = 1;
use Scalar::Util qw(looks_like_number);
our $HOME = $ENV{HOME};
our ($curdirori,$outdir); 
our (%progr,$progname);
our ($avisosgrav,$avisosnograv,$avisosnoseent)=(0,0,0);
our @MENSAJES;
our (%opt_hash,@opciones, $opciones, $debug, $noverb, $buscar, $imprlog);

BEGIN {
  use Exporter ();
  our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
  @ISA=qw(Exporter);
  @EXPORT=qw(
	     &avejec &avgrav &avnograv &avnoseent
             &abrir_paren
             &bien_cerrado
             &buscar_cierra_lissepa
             &cerrar_paren  &cerrar_paren_sepas &comas_invalidas
             &comfin 
             &compl_archivo 
             &copiar_valor
             &depurar_crudo
             &detectar_repeticiones
	     &eco &explic
             &union_conjunto &interseccion_conjunto &union_conorden
             &hash2texto &hashrenglon
             &impr_campo
             &impr_debug 
             &impr_debug_listas
             &impr_debug_hashes
             &impr_hash 
             &impr_hashrenglon
	     &impr_hashlis
             &impr_todo
             &juntar_por_paren_cur &juntar_por_paren_rec 
             &juntar_por_signos_y_paren
             &juntar_por_signosf_y_paren
             &mensajear
             &paraimpr3puntos 
             &parary
             &parentesis_bien
             &parentesis_bien_marcar
             &parser
             &particion
	     &pausa &pausadebug
             &puro_base_propiosin_puntoext
             &referir_sdir_to_pdir
	     &relativizar
             &resolver_outdir
             &sacar_paren_ext
             &simpl_directory
             &textear_MENSAJES
             &texto
             $avisosgrav $avisosnograv $avisosnoseent
             $curdirori 
             $HOME   
             $buscar $debug $noverb
             $outdir
             %opt_hash
	     %progr $progname 
             $imprlog
             @MENSAJES 
          );
};
END();
# ---------------------------------------------------------------------------
sub abrir_paren{
  comfin('comy abrir_paren',@_);
  # recibe un string y lo devuelve partido en dos (la concat. de los dos es
  # el de entrada;
  # si no termina con parentesis el segundo es vacio
  # si termina con parentesis el segundo empieza al abrirse el parentesis
  #    o al acabar... en cuyo caso se le agrega un # al comienzo y 
  #      devuelve un tercero 'error' 
  # el primero queda con el resto, que puede ser vacio.
  # asi que si el segundo no es vacio y no empezo con parentesis 
  # es porque  no pudo abrirlo
  my $dato = $_[0]; my $out3 = '';
  $dato !~ /\)$/ and return $dato,'',$out3;
  my @liscar = split '',$dato;
  my $numcierra = 1; my $out2 = ')';pop @liscar; 
  while (@liscar) {
      $_ = pop @liscar;
      $out2 = $_ . $out2;
      if ($_ eq ')') {$numcierra++;
      } elsif ($_ eq '(') {
         $numcierra--;
      };
      $numcierra == 0 and last;
  };
  my $out1 = join '',@liscar;
  $numcierra > 0 and $out2 = '#' . $out2 and $out3 ='error';
  comfin('finy abrir_paren',$out1,$out2,$out3); 
  return $out1,$out2,$out3;     
}#abrir_paren;
# ---------------------------------------------------------------------------
sub avejec{;
  propio("DE EJECUCION", $_[0]);
}#avejec
# ---------------------------------------------------------------------------
sub avgrav{
  $avisosgrav++;
  propio("GRAVE", $_[0]);
}#avgrav
# ---------------------------------------------------------------------------
sub avnograv{
  $avisosnograv++;
  propio("NO GRAVE?", $_[0]);
}#avnograv
# ---------------------------------------------------------------------------
sub avnoseent{
  $avisosnoseent++;
  # uso avisosnoseent(xxx1):
  #    xxx1: mensaje del aviso;
  #    se cuentan.      
  propio("NO SE ENTIENDE", "$_[0]\n                 se ignora");
  if (not $noverb) {
      print STDERR "        Continúa a pesar de ello?(s/y/n): ";
#      my $resp = <STDIN>;
#      lc($resp) !~ /[sy]/i and die"\n";
#      print STDERR "\n"; 
  }; 
}#avnoseent
# ---------------------------------------------------------------------------
sub bien_cerrado{
  # si recibe una expresion que empieza y termina con paréntesis:
  # devuelve 1 si se aparean el primero con el último
  # 0 si no se aparean.
  # 0 si no empieza o no termina con paréntesis
  my $dato = $_[0];
  if ($dato =~ /^\((.*)\)$/) {
      my @lista = split '', $dato;  
      my $numabre = 1;
      my $largo = length($dato); my $i;
      for ($i = 1; $i < $largo; $i ++) {  
          $lista[$i] eq '(' and $numabre ++;
          if ($lista[$i] eq ')') {
             $numabre --;
             $numabre == 0 and last;
          };          
      };
      $numabre == 0 and $i == $largo -1 and return 1 #bien_cerrado 
          or return 0; #bien_cerrado
  };
  return 0; #bien_cerrado    
}#bien_cerrado
# ---------------------------------------------------------------------------
sub buscar_cierra_lissepa{
  comfin('comy buscar_cierra_lissepa',@_);
  my($ip,$reflissepa) = @_;
  my($ipk,$antes,$despues,$queda) = [0,'','',''];
  my $numabre = 1;
  for ($ipk = $ip+2; $ipk < @$reflissepa; $ipk ++) {
      my $monton = $reflissepa->[$ipk];
      my @listacars = split '',$monton;
#      impr_debug(__LINE__.' Ayud $numabre,@listacars',[$numabre,'||',@listacars]);
      my $k= -1;
      while (@listacars and $numabre) {
          $k ++;
          my $car = shift @listacars;
          $car eq ')' and $numabre -- or $car eq '(' and $numabre ++;
#         impr_debug(__LINE__.' Ayud $numabre,@listacars',[$numabre,'||',@listacars]);
      };
      if ($numabre) {
      } else {
          $queda = ')';
          $despues = join '',@listacars;
          $antes = substr($monton,0,$k);
          last; 
     };   
  };#$ipk
  comfin('finy buscar_cierra_lissepa $numabre,$ipk,$antes,$despues'
	 ,$numabre,$ipk,$antes,$despues);
  return $numabre,$ipk,$antes,$despues
}#buscar_cierra_lissepa
# ---------------------------------------------------------------------------
sub cerrar_paren{
  # recibe un string y lo devuelve partido en dos (la concat. de los dos es
  # el de entrada;
  # si no comienza con parentesis el primero es vacio
  # si comienza con parentesis el primero termina al cerrarse el parentesis
  #    o al acabar... en cuyo caso se le agrega un # al final y 
  #    devuelve un tercero 'error' 
  # el segundo queda con el resto, que puede ser vacio.
  # asi que si el primero no es vacio y no termino con parentesis 
  # es porque  no pudo cerrarlo  
  comfin('comy cerrar_paren',@_);
  my $dato = $_[0]; my $out3 = ''; 
  $dato !~ /^\s*\(/ and return '',$dato,$out3;    
  my @liscar  = split '', $dato;  
  my $numabre = 1; my $out1 = '('; shift @liscar;
  while (@liscar) {
      $_ = shift @liscar;
      $out1 .= $_;
      if ($_ eq '(') {$numabre++;
      } elsif ($_ eq ')') {
          $numabre--;
          $numabre == 0 and last;
      };
  };
  my $out2 = join '',@liscar;
  $numabre > 0 and $out1 .= '#' and $out3 = 'error';
  comfin('finy cerrar_paren',$out1,$out2,$out3);
  return $out1,$out2,$out3;
}#cerrar_paren
# ---------------------------------------------------------------------------
sub cerrar_paren_sepas{
  comfin('comy cerrar_paren_sepas',@_);
# Si todo va bien, en los primeros elementos de $refsepa quedan:
# El de [0]comienza con (; lo de su izquierda queda en $pre);
# el [$ip] con el ) que cierra (lo que sobra queda en post
# expresion va sin los parentesis exteriores
  my ($refpal,$refsepa) = @_;
  impr_debug(__LINE__.' Ayud',Dumper $refsepa);
  my $ip; my $numabre = 1;my $coderr = ""; 
  my $out1; my $expresion = '';
  my $ultimo = @$refpal -1;
  impr_debug(__LINE__.' Ayud $ultimo',$ultimo);
  if ($refsepa->[0] !~ s/^([^\(\)]*)\((.*)$/$2/) {
      $coderr = 40;
  };
  if (not $coderr) {  
     $ip = 0; $expresion = "$refsepa->[0]$refpal->[0]";
     impr_debug(__LINE__.' Ayud $expresion',$expresion);
     while ($ip < $ultimo) {
          $ip++;
          impr_debug(__LINE__.' Ayud '.$ip,$refsepa->[$ip]);
	  if ($refsepa->[$ip] !~ /[\)\(]/) {
              $expresion .= "$refsepa->[$ip]$refpal->[$ip]";
              impr_debug(__LINE__.' Ayud $expresion',$expresion); 
          } else {
              my @liscar  = split '',$refsepa->[$ip]; $out1 = '';  
              while (@liscar) {
                  $_ = shift @liscar;
                  if ($_ eq '(') {
                      $numabre++;
                  } elsif ($_ eq ')') {
                      $numabre--;
                      $numabre == 0 and last;
	          };
                  $out1 .= $_;
              };
              $numabre > 0 and next; 
              $refsepa->[$ip] = $out1.')';
              $expresion .= $out1;
              impr_debug(__LINE__.' Ayud $expresion',$expresion); 
          };
      };
      if ($numabre > 0) {
          $coderr = 20;
      };
  };
  my $deltaip = $ip;
  comfin('finy cerrar_paren_sepas',$coderr,$deltaip,$expresion);
  return $coderr,$deltaip,$expresion;
}#cerrar_paren_sepas',@_);
# ---------------------------------------------------------------------------
sub comas_invalidas{
  #detecta subexpresiones listas que no son argumentos de funcion
  #simplifica las que no molestan ....
  my $expre = "lista$_[0]"; #para que no moleste una lista pura
  (my $coderr,my @lista) = juntar_por_paren_cur(',',split /\s*\,\s*/, $expre);
  @lista > 1  and return 1;
  while ($expre ne '' and $expre =~ s/(\w+)\s*\([^\(\)]+\)/$1/) {
  }; #elimino todas las posibles llamadas a funciones
  if ($expre =~ /\([^\(\)]+\,[^\(\)]+\)/) {return 1};
  return ''
} # comas_invalidas   
# ---------------------------------------------------------------------------
sub comfin{ #uso comfin('com xxxxxx', @_)   o comfin('fin xxxxxx', @_)
  # o comfin('fin xxxxxx', @_,$lisque,$ref,'impr')
  # o comfin('fin xxxxxx',,$lisque,$ref,'impr')
  # 'impr' para que llame a impr_datos con $lisque y $ref
  return ''  unless $debug;
  my @viene = @_;
  my $primera = shift @viene; my $cosa = ''; @viene and $cosa = $viene[0];
  my @refarchers =  @Simusol::GlobalesSimusol::refarchers;
  my @refgrafers =  @Simusol::GlobalesSimusol::refgrafers;
  my @reflayers =  @Simusol::GlobalesSimusol::refgrafers;
  if ($cosa) {
      if ($cosa =~ /^HASH/) {
          my @caliscosa;
          if ($cosa->{ARCHIVOCAPA}) {
              push @caliscosa, 'reflay';
	      print STDERR "parece reflay\n";
          };
          if ($cosa->{numfile} and $cosa->{capas}) {
              push @caliscosa, 'refarch';
              print STDERR "parece refarch\n";
          };
          if ($cosa->{hashclasegr}) {
              push @caliscosa, 'refgraf';
              print STDERR "parece refgraf\n"
          };
          if ($cosa->{numobj} and $cosa->{numcapa}) {
              push @caliscosa,'refcuadro';
	      print STDERR "parece refcuadro\n";
          };
          @caliscosa >1 and do {
            print STDERR ' @caliscosa ',__LINE__,' Ayud ' ,"@caliscosa\n";
          };
      };
  };
  my @simplif;
  foreach(@viene) {
#    impr_debug(__LINE__.' Ayud @viene',Dumper \@viene); 
     my $nuevo;
      my $texto = $_;
      if (not defined $texto) {
          $nuevo = 'no definido';
      } elsif ($texto =~   /^(ARRAY|HASH|SCALAR)\(/) {
          if ($texto =~ /^ARRAY\(/) { 
              my @lisundef = @$_; @lisundef = grep(do{not defined $_},@lisundef);
              if(@$_>8) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ')'    
              } elsif (@lisundef) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ' con undef)'
	      } else {
                 $nuevo = "[@$_]";
              }
          } elsif ($texto =~ /^HASH\(/) {
              $nuevo = 'HASH (' . scalar (keys (%$_ )) . ')'; 
 	      if (defined $_->{CORTOSIN}) {
	          $nuevo .= " - (($_->{CORTOSIN})): ";
              } elsif ($_->{numfile}) {
 	          my @refarchers = @Simusol::GlobalesSimusol::refarchers;
                  if (defined $refarchers[$_->{numfile}] and
                      defined $refarchers[$_->{numfile}]->{CORTOSIN}) { 
                      $nuevo .= 
                      " - ((capa de $refarchers[$_->{numfile}]->{CORTOSIN})): ";
                  };
              };
          } elsif ($texto =~ /^SCALAR\(/) {
	      $nuevo = 'SCALAR (' . length($$_) . ')';
          };
      } else {
          ($nuevo = $texto) =~ s/^\s*//;
          if ($nuevo eq '') {
              $nuevo = 'blanco';
          } elsif (length $nuevo < 16) {
          } elsif($nuevo =~ /^\//) {
              my $largo = length $nuevo; my $comi = $largo - 15;
              $nuevo = '...'. substr($nuevo,$comi); 
          } elsif (length $nuevo > 24) {
              $nuevo = substr($nuevo,0,24) .'...';
          };
          if ($texto =~ /,/) {
              $nuevo .= 'con comas';
          };
      };
      push @simplif, $nuevo;
  };
  my ($donde,$comfin);
  if ($_[0] =~ /^\s*(\w+)\s+(\S\w*)/){
     ($donde,$comfin) = ($1,$2);
    if (@_ >3 and defined $_[-1] and defined $_[-2] 
         and $_[-1] eq 'impr' and  $_[-2] =~ /HASH\(/ ) {
            impr_datos(
            "para $comfin pide comfin",['DATOS','PARAMETROS','INICIALES']
		  ,$_[-2]);
     };
  };
  eco(" $_[0](" . join(',',@simplif). ')'); #para comfin
  return '';
}#comfin
# -------------------------------------------------------------------------
sub compl_archivo{#devuelve el nombre completo, simplificado, del archivo;
  # si se quiere directorio se indica con $esdir 
  #           (y entonces controla existencia)
  #     o lo crea si ademas $crear 
  comfin('comy compl_archivo',@_);
  #$archivo: nombre del archivo en el diagrama
  #$pwd directorio donde esta el diagrama
  my ($archivo,$pwd,$esdir,$crear) = @_;
#  impr_debug(__LINE__.' Ayud $archivo',$archivo);
  $pwd =~/\/$/ or $pwd .= '/'; my $coderr = '';
  my $archivocompl = $archivo;
  if ($archivo =~ /^\~/) {
      my $HOME = $ENV{HOME};
      $archivocompl =~ s /^\~/$HOME/;
  } elsif ($archivo =~ /^\.\/(.*)$/) {
      $archivocompl = "$pwd$1";
  }; 
#  impr_debug(__LINE__.' Ayud $archivocompl',$archivocompl);
  while ($archivocompl =~ s/^\.\.\//\//) {};
#  impr_debug(__LINE__.' Ayud $archivocompl',$archivocompl);
  while ($archivocompl =~ s/^\.\//\//) {};
  impr_debug(__LINE__.' Ayud $archivocompl',$archivocompl);
  while ($archivocompl =~ s/\/\.$/\//) {};
  while ($archivocompl =~ s/\/\.\//\//) {};
  while ($archivocompl =~ s/\/\w+\/\.\.\//\//) {};
  while ($archivocompl =~ s/\/\w+\/\.\.$/\//) {};
#  impr_debug(__LINE__.' Ayud $archivocompl',$archivocompl);
  if ($archivocompl !~ /^\//) {
      $archivocompl = $pwd . $archivocompl;
  };
  # simplificar los '/../' y los '/./'
#  impr_debug(__LINE__.' Ayud $archivocompl',$archivocompl);
  $archivocompl =~ s/\/\.$/\//;
#  impr_debug(__LINE__.' Ayud $archivocompl',$archivocompl);
  $archivocompl =~ s/\/\w+\/\.\.$/\//;
#  impr_debug(__LINE__.' Ayud $archivocompl',$archivocompl);
  if ($esdir) {# queremos que sea directorio
     $archivocompl =~ s/(\w)$/$1\//;
     if (not -d $archivocompl) {
          if ($crear) {
              system "install -d $archivocompl 2>/dev/null";
              $? and parary(251, " No se pudo crear el directorio $archivo");
          } else {
              parary(251," No existe el directorio $archivo");
	  };
      };
  } elsif ($archivocompl =~ /\/$/) {#y  no se quiere directorio
      parary(252, "              $archivo
      no es un buen nombre para archivo no directorio");
  };  
  if (not $coderr and $archivocompl =~ /^\/\.\./) {
      parary(253, "              $archivo
      no es un buen nombre de archivo");
  };
  comfin('finy compl_archivo $coderr',$coderr,$archivocompl);
  return $coderr,$archivocompl;
}#compl_archivo
# ---------------------------------------------------------------------------
sub copiar_valor{# copia el valor del momento de la estrutura
  comfin('comy copiar_valor',@_);
  my $reforigen = $_[0];
  my $VAR1;
  my $texto = Dumper $reforigen;
  eval $texto;   
  comfin('finy copiar_valor');
  return $VAR1;
}#copiar_stru
# ---------------------------------------------------------------------------
sub depurar_crudo{ #saca comentarios y espacios... a 1 espacio
  # depura a $crudo que  supone es un texto formado de varios renglones;
  # eliminando comentarios (desde un # hacia la derecha; no los de ';' )
  # y limpia espacios al comienzo y al final
  #secuencias de blancos intermedios .. a 1 solo
  # devuelve lista de renglones depurados
  my $crudo = $_[0]; my $mensaje = '';
  comfin('comy depurar_crudo',@_);
  my @listain = split "\n", $crudo; my @listaout;my $reflistaout = \@listaout;
  impr_debug(__LINE__.' Ayud $crudo',"\n$crudo");
  my $hay = '';
  my @listainori = @listain;
  while ($listain[-1] =~ s/,\s*$//) {$hay = 1}; 
  foreach (@listain) {
      s/\#.*//; #quita comentarios
      next if /^\s*$/;
      s/^\s+//; s/\s+$//;
      s/\s+/ /g; s/,\s/,/g; s/\s,/,/g;
      while(s/^\s*,//) {$hay = 1};
      while(s/,\s*,/,/) {$hay = 1};
      while(s/\(\s*,/\(/) {$hay = 1};
      while(s/,\s*\)/\)/) {$hay = 1};
      push @listaout, $_ if $_;
  };
  if ($hay) {
     $mensaje = " Hay elementos vacios que se ignoran en\n    "
        . join ("\n    ",@listainori); 
#     mensajear ($mensaje);  
};
  impr_debug(__LINE__.' Ayud @listaout',Dumper $reflistaout);
  comfin('finy depurar_crudo',@$reflistaout);
  return $mensaje,$reflistaout;
}#depurar_crudo
# ---------------------------------------------------------------------------
sub detectar_repeticiones{
  #compara por igualdad de cosas que parecen numeros
  #o expresiones, unicamente  cambiando TIME por TIEMPO
  comfin('comy detectar_repeticiones',@_);
  my @lista = @_; my ($coderr,$mensaje) = ('','');
  my (@listanum,@listanonum);
  foreach (@lista) {
      if (looks_like_number($_)) {push @listanum,$_;
      } else {
          my $cosa = ";$_;";
          while ($cosa =~ s/(\W)TIME(\W)/$1TIEMPO$2/) {};
          $cosa =~ s/^;(.+);$/$1/; $_ = $cosa;
          push @listanonum,$cosa;
      };
  };
  # si ninguno es 0 ya esta mal
  my $oper = 'eq';
  if (@listanum * @listanonum) {$coderr = 1;
      print STDERR "$listanum[0] eq $listanonum[0] falso\n";
  } elsif (@listanum) {
      $oper = '==';
      my $cosa0 = $lista[0];
      foreach (@lista) {
          my $resu = eval("$cosa0 $oper $_");
          if (not $resu) {
              print STDERR "$cosa0 $oper $_ falso\n";
              $coderr = 1; last;
          };
      };
  };
  if ($coderr) {
     $mensaje = " los elementos del conjunto no parecen iguales\n";
  };
  #comfin('finy detectar_repeticiones',$coderr);
  return $coderr,$mensaje;
}#detectar_repeticiones
# ---------------------------------------------------------------------------
sub eco{ 
  return if $noverb and not $_[1];
  #para indicar qué está haciendo simusol; para depurar
  print "..... $_[0]\n";
  print STDERR "..... $_[0]\n";
  #si se usa > o 2> quedan separados
}#eco
# ---------------------------------------------------------------------------
sub explic{
  return if $noverb;   
  if (@_ != 1) {
      die "explic no tiene 1 argumento
          @_"
      };
    # para que sirva de ayuda al usuario; no va al archivo ls3
  if ($debug) {
      print STDERR  "........ $_[0]\n";
  } else {
      print         "........ $_[0]\n";
  };
}#explic
#---------------------------------------------------------------------------
sub hash2texto{
  #para una referencia a un hash, devuelve un renglón ..
  my $refhashtexto =$_[0]; my $texto= '';
  if ($refhashtexto =~/HASH/) {
      map(do {$texto .= " $_=$refhashtexto->{$_} "},sort keys %$refhashtexto);  
      $texto =~ s/ $//;
  };
  return $texto;
}
#----------------------------------------------------------------------------
sub hashrenglon{
  #para un hash dado por sí, forma un renglon ...
  my ($mensaje, %hash)=@_;
  my $texto = "$mensaje ";
  if (@_) {
     map(do{$texto .= "$_=>$hash{$_}; "},sort keys %hash);  
  } else {
      $texto .= '(vacio)';
  };   
  return "$texto\n";  
}#hashrenglon
# ---------------------------------------------------------------------------
sub impr_campo{
  return unless $debug;
  my($mensaje,$ref,$campo,$valor) = (@_,'','');
  print STDERR '$campo ',$campo,"\n";
  print STDERR ' $valor ',$valor,"\n";
  print STDERR " $mensaje      Empieza impr_campo_"; 
  if ($campo) {
      print STDERR "$campo ";
  } else {
      print STDERR "   falta campo\n";
      print STDERR " $mensaje      Termina impr_campo\n";
      return;
  };
  my $cosa;
  if ($valor) {
      print STDERR " || $valor || ";
      $cosa = valory($ref,$campo,$valor);
  } else {
      print STDERR " || falta valor\n";
      $cosa = $ref->{$campo};
  };
  if (not $cosa) {
      print STDERR " $mensaje      Termina impr_campo\n";
      return;
  };  
  if ($cosa =~ /ARRAY/) {
      print STDERR Dumper $cosa;
  } elsif ($cosa =~ /HASH/) {
      my $cosalimpia = {}; my (@vacios,@llenos);
      foreach my $cosita (sort keys %$cosa) {
          if ($cosa->{$cosita} =~ /ARRAY/) {
              if (@{$cosa->{$cosita}}) {
                  $cosalimpia->{$cosita} = $cosa->{$cosita};
                  push @llenos,$cosita;
              } else {
                  push @vacios,$cosita;
              };
          } elsif ($cosa->{$cosita} =~ /HASH/) { 
              print STDERR " para $cosita: ",Dumper $cosa->{$cosita};
          } else {
              print STDERR " para $cosita: $cosa->{$cosita}\n";   
          };
      };
      print STDERR "     Vacios : @vacios\n" if @vacios;
      print STDERR " ",Dumper $cosalimpia  if @llenos;
  } else {
      print STDERR " || $valor || $cosa\n";
  };
  print STDERR " $mensaje      Termina impr_campo\n";
  return;
}#impr_campo
# ---------------------------------------------------------------------------
sub impr_debug{
  return unless $debug;
  if (@_ != 2) {
      die "impr_debug no tiene dos argumentos
          @_"
      };
  my ($mensaje,$cosa) = @_;
  my $texto = ' impr_debug ';
  $texto .= "( $mensaje) " if defined $mensaje;
  (my $mens1 = $mensaje) =~ s/^(\d+ \w+).*$/$1/;
  if (length $texto > 60) {
      print STDERR ".....  $texto \n";
      $texto = "i_d $mens1 ";
  };
  if (not defined $cosa) {
      $texto .=" no definido\n";
  } elsif ($cosa =~ /^ARRAY\(/) {
      my $cosa1; @$cosa1 = @$cosa; 
      map(do{not defined $_ and $_ ='no definido' or
             $_ !~ /\S/ and $_ = 'blancos'},@$cosa1);
      $texto .= 'array ('.join (',', @$cosa1).")\n";       
  } elsif ($cosa =~ /^HASH\(/) {
      my @lista; 
      foreach my $key (sort keys %$cosa){
          my $algo = $cosa->{$key}; defined $algo or $algo = 'no def.';
          push @lista, "$key=>$algo";
      }; 
      $texto .= 'hash (' . join (',',@lista) .")\n";
  } elsif ($cosa =~ /^SCALAR\(/) { 
      $texto .=  "( escalar )$$cosa\n";
  } else { 
      $texto .= "$cosa\n";
  }; 
  print STDERR $texto;
}    
#---------------------------------------------------------------------------
sub impr_debug_listas{
  return unless $debug;
  my($mensaje,@listarefs) = @_;
  print STDERR 
    ".....  comy impr_debug_listas --- $mensaje ",scalar @listarefs,"\n";
  my $i = 0;
  my @vacias;
  foreach my $reflis (@listarefs) {
      $i++;
      if (defined $reflis and @$reflis) {
          print STDERR "- - - - - lista $i  con: ",scalar(@$reflis),"\n";
          print STDERR "@$reflis)\n";
      } else {
          push @vacias,$i;
      } 
  };
  @vacias and print STDERR "listas vacías:  @vacias\n";  
  print STDERR "finy impr_debug_listas --- $mensaje ",scalar @listarefs,"\n";
}#impr_debug_listas
#---------------------------------------------------------------------------
sub impr_debug_hashes{
  return unless $debug;
  my($mensaje,@hashesrefs) = @_;
  print STDERR "comy impr_debug_hashes --- $mensaje ",scalar @hashesrefs,"\n";
  my $i = 0;
  foreach my $refhash (@hashesrefs) {
      $i++; print STDERR "- - - - - hash $i\n";
      if (scalar keys %$refhash) {
          map (do {print STDERR "$_=>$refhash->{$_}\n"},keys %$refhash);
      };
  };  
  print STDERR "finy impr_debug_hashes --- $mensaje ",scalar @hashesrefs,"\n";
}#impr_debug_hashes
# ---------------------------------------------------------------------------
sub impr_hash{
  # un ultimo elemento, adicional al hash, sustituye impresion en STDOUT por
  #return
  my ($identy, @hash)=@_; my ($impr, $largo);
  my $cuantos = scalar @hash; 
  if (($cuantos % 2) ) {#numero impar de valores
     $impr = pop(@hash);
     $largo = $impr;    
  } else {    
     $impr = 0;
     $largo = length($identy) + 1; # en impr_hash 
  }; 
  impr_debug(__LINE__.'Ayud $cuantos $impr',[$cuantos,$impr]);
  my %hash = @hash;    
  my $texto ='';     
  foreach my $uno (sort keys %hash){
     $texto .= sprintf "%20s\n",  (' ' x $largo) . "$uno => $hash{$uno}"; 
  };
  if ($impr) {
     return $texto;
  } else {
     print "$identy --- hash: ",scalar keys %hash," ---\n";
     print "$texto\n";   
  }; 
}#impr_hash
#---------------------------------------------------------------------------
sub impr_hashrenglon{
   #imprime un hash dado por sí, todo en un renglón y sin identificación
   my ($mensaje, %hash)=@_;
   print "$mensaje ";
   if (@_) {
      map((print "$_=>$hash{$_};   "),sort keys %hash)  
   } else {
      print '(vacio)'
   };   
   print "\n"  
}#impr_hashrenglon
# ---------------------------------------------------------------------------
sub impr_todo{
#  comfin('com0 impr_todo',@_);
  return unless $debug;  
  my ($mensaje,$ref)= @_;
  print STDERR " Empieza impr_todo $mensaje (ref$progr{$progname})\n";
  if ($ref->{dirarray}) {
      print STDERR " dirarray: ",scalar @{$ref->{dirarray}};
      if (@{$ref->{dirarray}} == 1) {
	  print STDERR " archivo: $ref->{dirarray}->[0]\n";
      } else {
          print STDERR " archivos\n";
      };
  };	  
  foreach my $palabra (qw(juntos curdirori outdir outdirfinal PROPIOSIN)) {
      print STDERR " $palabra $ref->{$palabra}\n"
        if defined $ref->{$palabra};
  };
  foreach my $palabra 
    (qw(corto cortosin codigo_1 codigo_s codigo_3 basearchcorto)) {
     print STDERR " $palabra ",paraimpr3puntos(130,@{$ref->{$palabra}}),"\n"
	  if $ref->{$palabra};
  };    
  print STDERR " Termina impr_todo $mensaje\n";
#  comfin('fin0 impr_todo');
  return;
}#impre_todo
# ---------------------------------------------------------------------------
sub interseccion_conjunto{
  # Dadas dos referencias a listas devuelve otra  con los elementos comunes
  # es mas eficiente si en la primera no hay elementos repetidos
  my ($lista1,$lista2) = @_;
  my %hash;
  foreach my $ele (@$lista1) {
      map(do{$_ eq $ele and $hash{$_}= 1},@$lista2);
  };  
  return keys %hash;
}
# ---------------------------------------------------------------------------
sub juntar_por_paren_cur{# devuelve $coderr y @lista
  #si es posible, junta elementos de la lista (lo menos posible) 
  #para que los elementos tengan sus parentesis bien apareados
  #devuelve '' y la lista juntada
  # o devuelve un mensaje de error
  # $pega no debe ser  cuantificador: + -
  my ($pega,@listain) = @_;
  my @listaout;
  my ($abrecur, $cierracur, $coderr,$antcur)  = (0, 0, '','');
  @listain or return "Lista vacía",(); 
  foreach(@listain) {
      #impr_debug(__LINE__.' Ayud $_', $_); 
      $antcur .=  "$_$pega" ;
      $abrecur = ($antcur =~ tr/(//); $cierracur = ($antcur =~ tr/)//);
      if ($abrecur < $cierracur) {
          $coderr = 'Sobra paréntesis )';
          last;
      } elsif ( $abrecur == $cierracur) {
          $antcur =~ s/$pega$//;
          push @listaout,$antcur;  
          $antcur = '';$abrecur = $cierracur = 0;
      } 
  }; #@listain
  if ($abrecur > $cierracur) {
      $coderr = 'Sobra parentesis (';
  };
  return $coderr,@listaout    
}#juntar_por_paren_cur
# ---------------------------------------------------------------------------
sub juntar_por_paren_rec{# devuelve $coderr y @lista
  #si es posible, junta elementos de la lista (lo menos posible) 
  #para que los elementos tengan sus parentesis bien apareados
  #devuelve '' y la lista juntada
  # o devuelve un mensaje de error
  # $pega no debe ser  cuantificador: + -
  my ($pega,@listain) = @_;
  my @listaout;
  my ($abrerec,$cierrarec,$coderr,$antrec)  = (0, 0, '', '','');
  @listain or return "Lista vacía",(); 
  foreach(@listain) {
      #impr_debug(__LINE__.' Ayud $_', $_); 
      $antrec .=  "$_$pega" ;
      $abrerec = ($antrec =~ tr/[//); $cierrarec = ($antrec =~ tr/]//);
      if ($abrerec < $cierrarec) {
          $coderr = 'Sobra paréntesis ]';
          last;
      } elsif ( $abrerec == $cierrarec) {
          $antrec =~ s/$pega$//;
          push @listaout,$antrec;  
          $antrec = '';$abrerec = $cierrarec = 0;
      } 
  }; #@listain
  if ($abrerec > $cierrarec) {
      $coderr = 'Sobra parentesis [';
  };
  return $coderr,@listaout    
}# juntar_por_paren_rec
# ---------------------------------------------------------------------------
sub juntar_por_signos_y_paren{
  comfin('comy juntar_por_signos_y_paren',@_);
  my ($pega,@listain) = @_; my (@listaout,@listasinrevisar);
  my ($ant,$comm) = ('','');
#  impr_debug(__LINE__.' Ayud @listain',Dumper \@listain);
  my $juntado = join ("\n",@listain);
  #para juntar renglones (elementos de una lista)
  #  no 'pueden' comenzar con +*/,=)
  # un  - al comienzo se considera (operador uniario) 
  #no  'pueden' terminar con  +-*/,=( 
  #un renglon con = no inicial no se junta con el anterior, aunque quede
  #con parentesis u operaciones pendientes
  # los parentesis se tratan algebraicamente
  $juntado =~ s/([\,\+\-\*\/\=\(\:])\s*(&{0,1})\n/$1 $2/g;#signos finales
  $juntado =~ s/\n\s*([\,\+\*\/\=\)\:])/ $1/g; # signos iniciales
  @listain = split ("\n",$juntado);
  impr_debug(__LINE__.' Ayud @listain',Dumper \@listain);
  my ($numabre, $numcierra,$coderr,$mensaje) = (0,0,'','');
  my $cuantos = 0;
  # elementos vacios desaparecen; pero ya habian sido eliminados por
  #  depurar_crudo
  foreach(@listain){
      $cuantos ++;
      #impr_debug(__LINE__.' Ayud $_', $_); 
      if ($ant =~ s/;\s*(.+)$//) {
          $comm = " $1";
      };
      if ($ant eq '') {
          $ant = $_;
      } elsif (/^\s*\S.+=/) {
          push(@listaout,$ant);
          $cuantos = 1;
          $ant = $_;#puede salir con parentesis mal
      } else {
          $ant .= $pega . $_;#le saque la ,
      };
      $numabre = ($ant =~ tr/(//); $numcierra = ($ant =~ tr/)//);
      if ($numabre < $numcierra) {
          $coderr = 'Sobra paréntesis ) para '.$ant; $ant = '';
          last;
      } elsif ($numabre == $numcierra ) {
         push(@listaout,$ant); $ant = '';
         $cuantos = 0; 
      };
  }; #@listain
  if ($numabre > $numcierra) {
      $coderr = 'Sobra parentesis ( en '.$ant; $ant = '';
  };
  if ($coderr) {
      my $cuantosout = scalar @listaout;
      my $cuantosin = scalar @listain;
      impr_debug(__LINE__.' Ayud error',Dumper \@listain);
      @listasinrevisar = @listain[$cuantosout+1..$cuantosin - 1];
      impr_debug(__LINE__.' Ayud',Dumper \@listasinrevisar);
  }; 
  push(@listaout,$ant) if $ant ne  '';
  #impr_debug(__LINE__.' Ayud @listaout',Dumper \@listaout);
  comfin('finy juntar_por_signos_y_paren');
  return $coderr,@listaout;    
}#juntar_por_signos_y_paren
# ---------------------------------------------------------------------------
sub juntar_por_signosf_y_paren{
  my (@listain) = @_; my @listaout = (); my $ant = '';
  my $juntado = join ("\n",@listain);
  # no  'pueden' terminar con ,;
  # y se intentan parentesis apareados 
  # con parentesis u operaciones pendientes
  # los parentesis se tratan algebraicamente
  $juntado =~      s/([\,\+\-\*\/\=])\s*\n/$1/g; # , finales
  @listain = split ("\n",$juntado);
  my ($numabre, $numcierra) = (0,0);
  foreach(@listain){
      next unless $_; 
      $ant .= $_; 
      $numabre = ($ant =~ tr/(//); $numcierra = ($ant =~ tr/)//);
      #print 'Ayud ' . __LINE__ . " abre $numabre cierra $numcierra ant $ant \n";
      do {push(@listaout,$ant); $ant = ''} 
          if ($numabre <= $numcierra );#puede haber errores que se detectaran despues
  }; #@listain
  push(@listaout,$ant) if $ant ne  '';
  return (@listaout)    
}# juntar_por_signosf_y_paren 
# ---------------------------------------------------------------------------
sub mensajear{
#  comfin('com mensajear',@_);
  if (@_ != 1) {
      die "mensajear no tiene 1 argumento
          @_"
  };
  my $agre = ' _ _ _ _ '; 
  if ($debug) {
     print STDERR "$agre$_[0]\n";
  } else {
      print "$agre$_[0]\n";
  };
  no warnings;
  if (tell(SALIDAls3)) {
     print SALIDAls3 "$_[0]\n"};
}#mensajear
#----------------------------------------------------------------------------
sub paraimpr3puntos{
  my ($largo,@lista) = @_;my $dato = join(' ',@lista);
  length($dato) < $largo or  $largo < 5  # en paraimpr3puntos
    or $dato = substr($dato,0,$largo - 4) . '...';
  return $dato;
}
# ---------------------------------------------------------------------------
sub parary{
  my ($codigo,$mensaje) = @_;
  print STDERR "$mensaje\n" if $mensaje;
 # print STDERR ' ' x 30,"Salgo de $progname con $codigo\n";
 # print ' ' x 30,"Salgo de $progname con $codigo\n";
  exit $codigo;
}
# ---------------------------------------------------------------------------
sub parentesis_bien{
  my $dato = $_[0];
  #impr_debug(__LINE__.' Ayud $dato', $dato);
  my @liscar  = split '', $dato; my @lisizq; my $abr = 0; 
  #impr_debug(__LINE__.' Ayud $abr,aaa,@lisizq,bbb,@liscar'
 #	     ,[$abr,'aaa',@lisizq,'bbb',@liscar]);
  my $pasado = ''; my $entrep; my $cerrado= '';
  while (@liscar) {
      $_ = shift @liscar; 
      if (/\(/) {
          $abr ++;
          if ($abr > 1) {
              $entrep .='(';
          } else {
              $entrep = '( ';
              $cerrado .= $pasado;
              $pasado = '';
          }; 
      } elsif (/\)/) {
          $abr --; $entrep .= ')'; 
          if ($abr == 0) {
              #impr_debug(__LINE__.' Ayud entreparentesis', $entrep);
              $entrep ='';
          } elsif ($abr < 0) {
              last;
          };
      } elsif ($abr > 0) { 
          $entrep .= $_;
      #} elsif ($abr == 0) {
      #    $cerrado .= $_;
      };
      $pasado .= $_;
  };
  my $pendiente = join '',@liscar;
  $abr < 0 and return "Sobra paréntesis ) : $pasado ) $pendiente" 
   or $abr > 0 and return "Sobra paréntesis \( : $cerrado $entrep" 
   or return  '';
} # parentesis_bien   
# ---------------------------------------------------------------------------
sub parentesis_bien_marcar{#devuelve $coderr, con texto, si hay error
# o quiebre (por posible detalle en pedido de resultados);
#  la expresion transformada y la pendiente, pues
#    sustituye los parentesis que podrian indicar funciones por []
# puede haber [] que en realidad sean indicadores de quiebres
# pero no se piede ninguna posibilidad de []
# no todos los quiebres se detectan
  comfin('comy parentesis_bien_marcar',@_);
  my $dato = $_[0];
  my @liscar  = split '', $dato; my @lisizq; my $abr = 0; my ($para,$parc); 
  my $pasado = ''; my $entrep; my $cerrado= ''; my $ultimo = '+';my @listacie;
  my $newexpr= '';my $coderr= '';my $pendiente = '';
  while (@liscar) {
      $_ = shift @liscar; #print "               $ultimo $_\n" if $_ ne ' ';
      if ($_ eq ' ') {
	  $newexpr .= ' ';next;
      } elsif (/\(/) {
          if ($ultimo eq ')') {
              $coderr = 'quiebre';$pendiente = '(';
              last;
          };
          $abr ++;
          if ($ultimo =~ /[-+*\/,\(\s]/) {
              $para = '('; push @listacie,')';
          } elsif ($ultimo =~ /\w/) {
              $para = '['; push @listacie,']';
          };
#          print "luego de ( listacie: @listacie\n";
          $newexpr .= $para;
          if ($abr > 1) {
              $entrep .=$para;
          } else {
              $entrep = "$para ";
              $cerrado .= $pasado;
              $pasado = '';
          }; 
      } elsif (/\)/) {
 #         print "luego de ) listacie antes de retirarlo: @listacie\n";
          if ($abr > 0) {
              $parc = pop @listacie;
              $abr --; $entrep .= $parc;
              $newexpr .= $parc; 
          } elsif ($abr == 0) {
              #impr_debug(__LINE__.' Ayud entreparentesis', $entrep);
              $entrep ='';
          } else {
              last;
          };
      } elsif ($_ eq ';') {
          $coderr = '  ; inesperado';
          last;
      } else {
          $newexpr .= $_;
          $entrep .= $_;
      };
      $pasado .= $_;
      $ultimo = $_;
  };
  $pendiente .= join '',@liscar;
  $abr < 0 and $coderr = "Sobra paréntesis ) : 
       pasado:   $pasado ) pendiente:   $pendiente" 
  or $abr > 0 and $coderr =  "Sobra paréntesis \( :
       cerrado:  $cerrado   entrep:   $entrep";
  comfin('finy parentesis_bien_marcar',$coderr,$newexpr,$pendiente); 
  return  $coderr,$newexpr,$pendiente;
}#parentesis_bien_marcar   
# ---------------------------------------------------------------------------
sub parser{
  # comfin('comy parser', @_);
  # se usa @resultados = parser(@separadores,$expresion);
  my ($sepi,$sepc,$sepd,$expresion) = @_;
  my (@lisi,@lisd);my ($lisi,$lisd);
  if ($expresion =~ /([^$sepc]+)\s*$sepc\s*(.*)/) {
      $lisi = $1; $lisd = $2; $lisd =~ s/\s*$//;
      @lisi = split(/$sepi/,$lisi);
      @lisd = split(/$sepd/,$lisd);
      (@lisi == 2   and @lisd) or return 'error';  
      $lisd[-1] =~ s/\s*$//;
      (my $coderr,@lisd)  = juntar_por_paren_cur(',',@lisd);
  } else {return 'error'};
  #comfin('finy parser');
  return  (\@lisi,$sepc,\@lisd,$lisd);
} # parser 
# ---------------------------------------------------------------------------
sub pausa{
    my ($msg) =(@_,'sin mensaje');
    print STDERR "      (CTRL-C para terminar con esto):\n"
         . "             $msg: "; 
    my $dummy = <STDIN>;
    explic('');
    return
}
# ---------------------------------------------------------------------------
sub pausadebug{
    return if not $debug; 
    pausa(@_);
}
# ---------------------------------------------------------------------------
sub pausaver{
   my ($mensaje,$tarea)=@_;
   mensajear($mensaje);
   mensajear(
       "              Continúe $tarea
                        con   ENTER-RETURN;
               Interrumpa con CTRL-C");
   my $resp = <STDIN>;
   mensajear('') if $debug; 
}    
# ---------------------------------------------------------------------------
sub propio{
  my ($codigo,$mensaje) = @_;
  my $que = "ERROR $codigo";
  my $quien = ': ';
  #impr_debug(__LINE__.' Ayud',[$que,$quien,$mensaje,$progname]);
  #impr_debug(__LINE__.' Ayud',\%progr);
  my $cual ='';
  defined $progr{$progname} and $cual = "($progr{$progname}) ";
  if($debug or $noverb) {
      print STDERR "$cual$que$quien$mensaje\n";
  } else {
      print "$cual$que$quien$mensaje\n";
  };
}#propio
# -------------------------------------------------------------------------
sub puro_base_propiosin_puntoext{
  # devueve en $puntoext la extension con su punto o '';
  #  '' no tiene punto ni extension
    my $archivo = $_[0]; my $coderr = '';
#  impr_debug(__LINE__.' Ayud $archivo',$archivo);
  my ($base,$propio,$propiosin,$puntoext)
    = ('','','','');
  if ($archivo =~ /\w$/ or $archivo =~ /\w\.$/) {
      if ($archivo =~ /^(.*)\/([^\/]*)$/) {
          $base = $1; $propio = $2;
      } else {
          $propio = $archivo;
      };
      if ($propio =~ /(..*)\.(\w*)$/) {
          $propiosin = $1; $puntoext = '.' .$2;
      } else {
          $propiosin = $propio;
      };
      if ($base =~ /\/\.\.\// or $base =~/^\.\.\// or $base =~ /\/\.\.$/) {
          print " $archivo     Nombre no aceptable, por su base\n";
          $coderr = 1;
      }; 
  } else {
      print " Parece directorio\n";
      $base = $archivo;
      $coderr = 2;
  };
  return $coderr,$base,$propiosin,$puntoext; 
}
# -------------------------------------------------------------------------
sub referir_sdir_to_pdir{
#ambos dir dados en forma absoluta
  my (%partes,%cosas,%cuantos);
  ($cosas{pdir},$cosas{sdir}) = @_;my $coderr = 0;
  foreach my $pal (qw( pdir sdir)) { 
      $cosas{$pal} !~ /^\// and return 200;
      @{$partes{$pal}} = split '/',$cosas{$pal};
      @{$partes{$pal}} = grep(do {$_ ne ''}
                         , @{$partes{$pal}}); 
 #     impr_debug(__LINE__.' Ayud $partes{$pal}} '.$pal,$partes{$pal});
      $cuantos{$pal} = scalar  @{$partes{$pal}};
  };
  my $iguales = 1;
  if ($cuantos{sdir} < $cuantos{pdir}) {
      $coderr = 90;
  } else {
      my $i = -1; 
      while ($i < $cuantos{pdir}-1) {
          $i ++;
#          impr_debug(__LINE__.' Ayud'
#            , [$i,$partes{pdir}->[$i],$partes{sdir}->[$i]]); 
          if ($partes{pdir}->[$i] ne $partes{sdir}->[$i]) {
              $iguales = ''; last;
          };
      };
      if ($iguales) {
#          impr_debug(__LINE__.' Ayud hasta $cuantos{pdir}'
#            ," hasta $cuantos{pdir} iguales" );
      } else {
          $coderr = $i+1;
          impr_debug(__LINE__.' Ayud',"$i para distintos");  
      };
      if (not $coderr) {
          impr_debug(__LINE__.' Ayud $partes{sdir}',$partes{sdir});
          my $sdir = join ('/'
           , @{$partes{sdir}}[$cuantos{pdir}..$cuantos{sdir}-1]);
          return $coderr,$sdir;
      } else {       
          return $coderr; 
      };
  };
}#referir_sdir_to_pdir
# -------------------------------------------------------------------------
sub relativizar{
  #se espera nombre completo para $pwd, con su barra final 
  # y tambien completo para $arch salvo que puede tener o no la extension
  comfin('comy relativizar',@_);
  my ($arch,$pwd) = @_;
  (my $archsin = $arch) =~ s/\.\w+$//;
  $archsin =~s/\.\w*$//;
  my ($basearch, $propiosin, $cortosin,$pre);
  $archsin =~ /(.*\/)(.*)$/; # seguro se cumple esto
  $basearch = $1; #tiene la barra final
  $propiosin = $2;
  ($cortosin = $archsin) =~s/^$pwd//;
  impr_debug(__LINE__.' Ayud $basearch,$pre',[$basearch,$pre]);
  comfin('finy relativizar',$basearch, $propiosin, $cortosin,$pre);
  return $basearch, $propiosin, $cortosin,$pre;
}#relativizar
# ---------------------------------------------------------------------------
sub resolver_outdir{#
#lo usa simusol.pl
  comfin('comy resolver_outdir de /home/inenco/share/simusol/Simusol',@_);
  my $ref = $_[0];  
  my $outdirori = my $curdirori = $ref->{curdirori}; my $coderr = '';
  if ($opt_hash{outdir}) {
      $outdirori = $opt_hash{outdir};
      -d $outdirori or die " $outdirori no es un directorio; no sirve para recibir archivos";
      $outdirori !~ /^\// and $outdirori ="$curdirori$outdirori";
  };  
  ($coderr,$outdir) = simpl_directory($outdirori);
  if (not $coderr) {
      my $owner =  `stat -c %U $outdir`; chomp $owner;
      my $usted =  `whoami`;chomp $usted;
      impr_debug(__LINE__.' Auxi $owner,$usted',[$owner,$usted]);
      $owner eq $usted or die "    El directorio $outdir no sirve para outdir;
        pertenece a $owner y usted es $usted\n"; 
      my $attr = `stat -c %A $outdir`;
      $attr =~ /r.x$/ or die "    El directorio $outdir no sirve para outdir;
        no tiene los permisos necesarios. 
          Proponga uno adecuado con la opcion -outdir\n";
      $coderr and parary(250);
  };
  $ref->{outdir} = $outdir;    
  comfin('finy resolver_outdir');
  return ''
}#resolver_outdir';
 # ---------------------------------------------------------------------------
sub sacar_paren_ext{
  #recibe un string y devuelve un escalar  solo, -1, como error
  # o una terna  númeropositivo o nulo ,string, string:
  # el numero la cantidad de pares de parentesis exteriores sacados; 
  # el segundo lo de adentro; y el resto
  # se supone que no hay errores de parentesis
  comfin('comy sacar_paren_ext',@_);
  my ($dato,$resto,$error,$cuantos) = ($_[0],'','',-1);
  if ($dato =~ /^\(/) {
      $cuantos = 0;
      ($dato,$resto,$error) = cerrar_paren($dato);
      while (bien_cerrado($dato)) {$dato =~ s/^\((.*)\)$/$1/; $cuantos++};
  };
  comfin('finy sacar_paren_ext $cuantos,$dato,$resto',$cuantos,$dato,$resto);
  return ($cuantos, $dato,$resto);
}#sacar_paren_ext
# ---------------------------------------------------------------------------
sub simpl_archivo{ #elimina '..' intercalados en nombre de archivo
    #se supone que no hay errores de sintaxis ni espacios 
    # al princ.ni al final
    # y que no termina en /, pues no es un directorio, pero si empieza con /
    my $arch = $_[0]; $arch =~ s/^\///;
    my @lista = split /\//, $arch;
    @lista = grep (do{$_ ne '.'}, @lista);
    my $hay =1;
    while ($hay){
        $hay ='';
        for(my $i = 0; $i <@lista-1; $i ++) {
            if ($lista[$i+1] eq '..'  and $lista[$i] ne '..') {
 	        delete $lista[$i]; delete $lista[$i+1]; 
                if (defined $lista[$i+2] and $lista[$i+2] eq '..') {
                    $hay= 1;
                }
                $i ++;
	    } ;
        };
        @lista = grep(defined $_,@lista);    
    };  #ya no hay '..' intercalados
    my @listadospuntos = grep($_ eq '..',@lista);
    return '/'. join '/',@lista;
}#simpl_archivo
# ---------------------------------------------------------------------------
sub simpl_directory{ #elimina '..' o '.' intercalados en nombre del directorio
  comfin('comy simpl_directory',@_); 
  my $direin = $_[0]; my ($coderr,$direout) = ('',$direin);
  my $curdir = `pwd`;chomp $curdir;
  if (-d $direin) {
      chdir $direin;
      $direout = `pwd`; chomp $direout;$direout =~ s/([^\/])$/$1\//;
  } else {
      $coderr = 1;
  };
  chdir $curdir;# si $curdir no fue chompeado, resultaria inutil  
  comfin('finy simpl_directory',$coderr,$direout);
  return $coderr,$direout; 
}#simpl_directory 
# ---------------------------------------------------------------------------
sub textear_MENSAJES{
  my $texto = '   '. join("   \n",@MENSAJES);
  @MENSAJES = ();
  return $texto;
}#textear_MENSAJES
# ---------------------------------------------------------------------------
sub texto{
    # texto que debe ser traducido a otro idioma (además de los mensaje etc)
    return $_[0];
}
# ---------------------------------------------------------------------------
sub union_conjunto{
  # Dada un lista devuelve la "misma" sin elementos repetidos (no respeta orden)
  my %hash; my @lista;
  foreach (@_) {
      next unless defined $_;
      push @lista,$_ unless defined $hash{$_};
      $hash{$_} = 1;
  };
  return @lista;
}
# ---------------------------------------------------------------------------
sub union_conorden{
  # Dada un lista devuelve la "misma" sin elementos repetidos 
  my @lista = @_;
  my %hash;
  foreach (@lista) {
      next unless defined $_;
      if ($hash{$_}) {
          $_ = undef;
      } else {
          $hash{$_} = 1
     }; 
  };
  @lista = grep (defined $_,@lista);
  return @lista;
}
# ---------------------------------------------------------------------------
sub valory{#como el valor de GlobalesSimusol
  # comfin('comy valor',@_);
  my ($ref,$aspecto,$cosa) = @_;
  my $posivalor;
  # impr_debug(__LINE__.' Ayud'." $aspecto",$ref->{$aspecto}); 
  # impr_debug(__LINE__.' Ayud'." $aspecto $cosa",$ref->{$aspecto}->{$cosa}); 
  my $refglob = $Simusol::GlobalesSimusol::refglobal;
  if ($ref and $ref->{$aspecto} and defined $ref->{$aspecto}->{$cosa}) {
      $posivalor = $ref->{$aspecto}->{$cosa};    
      # impr_debug(__LINE__.' Ayud $cosa,$aspecto,$posivalor'
      #   ,[$cosa,$aspecto,$posivalor]);
  } elsif ($refglob->{$aspecto} and
            defined $refglob->{$aspecto}-> {$cosa}) {
      $posivalor = $refglob->{$aspecto}->{$cosa};
  };
  # impr_debug(__LINE__.' Ayud $cosa,$aspecto,$posivalor'
  #   ,[$cosa,$aspecto,$posivalor]);
  defined $posivalor and return $posivalor;
  $aspecto =~ /^(REFARG|USA|listaargFUNCION)$/ and return [];
  # comfin('finy valor');
  return ''; 
}#valor
# --------------------------------------------------------------------------
1;
